﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Shell;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;
using WindowsGame1;
using System.Windows.Media.Imaging;
using System.Windows.Resources;
using Microsoft.Phone;
using System.Collections.ObjectModel;
using System.Text;
using Microsoft.Win32;
using System.IO;
using System.Windows.Interop;
using System.IO.IsolatedStorage;
using Microsoft.Xna.Framework.Media;

namespace SlXnaApp1
{
    public partial class App : Application
    {
        public Igra nasaIgra { get; set; }
        public Nastavitve naseNastavitve { get; set; }
        public List<NastavitevIgralcev> zbirkaIgralci;
        public List<Igralec> playeri;
        public int trenutnaMapa;
        /*
            0 - privzeta
            1 - generirana naključno
            2 - generirana preko točk (razpoznave)
        */
        public DCT mojDCT;
        public bool narejenDCT;

        public bool zvok;
        public bool pause;
        public bool zajetaSlika;
        public string napaka;
        public bool spremembe;

        public List<ImageBrush> zbirkaNavodila;
        public List<ImageBrush> zbirkaPomoc;
        private ImageBrush brush;

        public int jeZmagovalec; // index zmagovalca

        /// <summary>
        /// Provides easy access to the root frame of the Phone Application.
        /// </summary>
        /// <returns>The root frame of the Phone Application.</returns>
        public PhoneApplicationFrame RootFrame { get; private set; }

        /// <summary>
        /// Provides access to a ContentManager for the application.
        /// </summary>
        public ContentManager Content { get; private set; }

        /// <summary>
        /// Provides access to a GameTimer that is set up to pump the FrameworkDispatcher.
        /// </summary>
        public GameTimer FrameworkDispatcherTimer { get; private set; }

        /// <summary>
        /// Provides access to the AppServiceProvider for the application.
        /// </summary>
        public AppServiceProvider Services { get; private set; }

        /// <summary>
        /// Constructor for the Application object.
        /// </summary>
        public App()
        {
            // Global handler for uncaught exceptions.
            nasaIgra = new Igra(666);
            this.zbirkaIgralci = new List<NastavitevIgralcev>();
            this.zbirkaIgralci.Add(new NastavitevIgralcev(1, "igralec1", true, System.Windows.Media.Color.FromArgb(255, 255, 0, 0)));
            this.zbirkaIgralci.Add(new NastavitevIgralcev(2, "računalnik2", false, System.Windows.Media.Color.FromArgb(255, 0, 128, 0)));
            this.trenutnaMapa = 0;
            this.zvok = true;
            this.pause = false;
            this.zajetaSlika = false;
            this.napaka = "";
            DCT.InitClass(); // izračun tabele (cos)
                  
            this.playeri = new List<Igralec>();
            this.playeri.Add(new Igralec(tipIgralca.clovek, "igralec1", Microsoft.Xna.Framework.Color.Red));
            this.playeri.Add(new Igralec(tipIgralca.racunalnik, "računalnik2", Microsoft.Xna.Framework.Color.Blue));

            this.zbirkaNavodila = new List<ImageBrush>();
            this.DodajNavodila();
            this.zbirkaPomoc = new List<ImageBrush>();
            this.DodajPomoc();

            this.jeZmagovalec = -1;

            UnhandledException += Application_UnhandledException;

            // Standard Silverlight initialization
            InitializeComponent();

            // Phone-specific initialization
            InitializePhoneApplication();

            // XNA initialization
            InitializeXnaApplication();

            // Show graphics profiling information while debugging.
            if (System.Diagnostics.Debugger.IsAttached)
            {
                // Display the current frame rate counters.
                Application.Current.Host.Settings.EnableFrameRateCounter = true;

                // Show the areas of the app that are being redrawn in each frame.
                //Application.Current.Host.Settings.EnableRedrawRegions = true;

                // Enable non-production analysis visualization mode, 
                // which shows areas of a page that are handed off to GPU with a colored overlay.
                //Application.Current.Host.Settings.EnableCacheVisualization = true;

                // Disable the application idle detection by setting the UserIdleDetectionMode property of the
                // application's PhoneApplicationService object to Disabled.
                // Caution:- Use this under debug mode only. Applications that disable user idle detection will continue to run
                // and consume battery power when the user is not using the phone.
                PhoneApplicationService.Current.UserIdleDetectionMode = IdleDetectionMode.Disabled;
            }
        }

        private void DodajNavodila()
        {
            this.brush = new ImageBrush();
            this.brush.ImageSource = new BitmapImage(new Uri("Navodila/navodila02.jpg", UriKind.Relative));
            this.zbirkaNavodila.Add(brush);

            this.brush = new ImageBrush();
            this.brush.ImageSource = new BitmapImage(new Uri("Navodila/navodila03.jpg", UriKind.Relative));
            this.zbirkaNavodila.Add(brush);

            this.brush = new ImageBrush();
            this.brush.ImageSource = new BitmapImage(new Uri("Navodila/navodila04.jpg", UriKind.Relative));
            this.zbirkaNavodila.Add(brush);

            this.brush = new ImageBrush();
            this.brush.ImageSource = new BitmapImage(new Uri("Navodila/navodila05.jpg", UriKind.Relative));
            this.zbirkaNavodila.Add(brush);

            this.brush = new ImageBrush();
            this.brush.ImageSource = new BitmapImage(new Uri("Navodila/navodila06.jpg", UriKind.Relative));
            this.zbirkaNavodila.Add(brush);

            this.brush = new ImageBrush();
            this.brush.ImageSource = new BitmapImage(new Uri("Navodila/navodila07.jpg", UriKind.Relative));
            this.zbirkaNavodila.Add(brush);

            this.brush = new ImageBrush();
            this.brush.ImageSource = new BitmapImage(new Uri("Navodila/navodila08.jpg", UriKind.Relative));
            this.zbirkaNavodila.Add(brush);

            this.brush = new ImageBrush();
            this.brush.ImageSource = new BitmapImage(new Uri("Navodila/navodila09.jpg", UriKind.Relative));
            this.zbirkaNavodila.Add(brush);

            this.brush = new ImageBrush();
            this.brush.ImageSource = new BitmapImage(new Uri("Navodila/navodila10.jpg", UriKind.Relative));
            this.zbirkaNavodila.Add(brush);

            this.brush = new ImageBrush();
            this.brush.ImageSource = new BitmapImage(new Uri("Navodila/navodila11.jpg", UriKind.Relative));
            this.zbirkaNavodila.Add(brush);
        }

        private void DodajPomoc()
        {
            this.brush = new ImageBrush();
            this.brush.ImageSource = new BitmapImage(new Uri("Pomoc/pomoc02.jpg", UriKind.Relative));
            this.zbirkaPomoc.Add(brush);

            this.brush = new ImageBrush();
            this.brush.ImageSource = new BitmapImage(new Uri("Pomoc/pomoc03.jpg", UriKind.Relative));
            this.zbirkaPomoc.Add(brush);

            this.brush = new ImageBrush();
            this.brush.ImageSource = new BitmapImage(new Uri("Pomoc/pomoc04.jpg", UriKind.Relative));
            this.zbirkaPomoc.Add(brush);

            this.brush = new ImageBrush();
            this.brush.ImageSource = new BitmapImage(new Uri("Pomoc/pomoc05.jpg", UriKind.Relative));
            this.zbirkaPomoc.Add(brush);

            this.brush = new ImageBrush();
            this.brush.ImageSource = new BitmapImage(new Uri("Pomoc/pomoc06.jpg", UriKind.Relative));
            this.zbirkaPomoc.Add(brush);

            this.brush = new ImageBrush();
            this.brush.ImageSource = new BitmapImage(new Uri("Pomoc/pomoc07.jpg", UriKind.Relative));
            this.zbirkaPomoc.Add(brush);

            this.brush = new ImageBrush();
            this.brush.ImageSource = new BitmapImage(new Uri("Pomoc/pomoc08.jpg", UriKind.Relative));
            this.zbirkaPomoc.Add(brush);

            this.brush = new ImageBrush();
            this.brush.ImageSource = new BitmapImage(new Uri("Pomoc/pomoc09.jpg", UriKind.Relative));
            this.zbirkaPomoc.Add(brush);

            this.brush = new ImageBrush();
            this.brush.ImageSource = new BitmapImage(new Uri("Pomoc/pomoc10.jpg", UriKind.Relative));
            this.zbirkaPomoc.Add(brush);

            this.brush = new ImageBrush();
            this.brush.ImageSource = new BitmapImage(new Uri("Pomoc/pomoc11.jpg", UriKind.Relative));
            this.zbirkaPomoc.Add(brush);

            this.brush = new ImageBrush();
            this.brush.ImageSource = new BitmapImage(new Uri("Pomoc/pomoc12.jpg", UriKind.Relative));
            this.zbirkaPomoc.Add(brush);
        }

        // Code to execute when the application is launching (eg, from Start)
        // This code will not execute when the application is reactivated
        private void Application_Launching(object sender, LaunchingEventArgs e)
        {
        }

        // Code to execute when the application is activated (brought to foreground)
        // This code will not execute when the application is first launched
        private void Application_Activated(object sender, ActivatedEventArgs e)
        {
        }

        // Code to execute when the application is deactivated (sent to background)
        // This code will not execute when the application is closing
        private void Application_Deactivated(object sender, DeactivatedEventArgs e)
        {
        }

        // Code to execute when the application is closing (eg, user hit Back)
        // This code will not execute when the application is deactivated
        private void Application_Closing(object sender, ClosingEventArgs e)
        {
        }

        // Code to execute if a navigation fails
        private void RootFrame_NavigationFailed(object sender, NavigationFailedEventArgs e)
        {
            if (System.Diagnostics.Debugger.IsAttached)
            {
                // A navigation has failed; break into the debugger
                System.Diagnostics.Debugger.Break();
            }
        }

        // Code to execute on Unhandled Exceptions
        private void Application_UnhandledException(object sender, ApplicationUnhandledExceptionEventArgs e)
        {
            if (System.Diagnostics.Debugger.IsAttached)
            {
                // An unhandled exception has occurred; break into the debugger
                System.Diagnostics.Debugger.Break();
            }
        }

        #region Phone application initialization

        // Avoid double-initialization
        private bool phoneApplicationInitialized = false;

        // Do not add any additional code to this method
        private void InitializePhoneApplication()
        {
            if (phoneApplicationInitialized)
                return;

            // Create the frame but don't set it as RootVisual yet; this allows the splash
            // screen to remain active until the application is ready to render.
            RootFrame = new PhoneApplicationFrame();
            RootFrame.Navigated += CompleteInitializePhoneApplication;

            // Handle navigation failures
            RootFrame.NavigationFailed += RootFrame_NavigationFailed;

            // Ensure we don't initialize again
            phoneApplicationInitialized = true;
        }

        // Do not add any additional code to this method
        private void CompleteInitializePhoneApplication(object sender, NavigationEventArgs e)
        {
            // Set the root visual to allow the application to render
            if (RootVisual != RootFrame)
                RootVisual = RootFrame;

            // Remove this handler since it is no longer needed
            RootFrame.Navigated -= CompleteInitializePhoneApplication;
        }

        #endregion

        #region XNA application initialization

        // Performs initialization of the XNA types required for the application.
        private void InitializeXnaApplication()
        {
            // Create the service provider
            Services = new AppServiceProvider();

            // Add the SharedGraphicsDeviceManager to the Services as the IGraphicsDeviceService for the app
            foreach (object obj in ApplicationLifetimeObjects)
            {
                if (obj is IGraphicsDeviceService)
                    Services.AddService(typeof(IGraphicsDeviceService), obj);
            }

            // Create the ContentManager so the application can load precompiled assets
            Content = new ContentManager(Services, "Content");

            // Create a GameTimer to pump the XNA FrameworkDispatcher
            FrameworkDispatcherTimer = new GameTimer();
            FrameworkDispatcherTimer.FrameAction += FrameworkDispatcherFrameAction;
            FrameworkDispatcherTimer.Start();
        }

        // An event handler that pumps the FrameworkDispatcher each frame.
        // FrameworkDispatcher is required for a lot of the XNA events and
        // for certain functionality such as SoundEffect playback.
        private void FrameworkDispatcherFrameAction(object sender, EventArgs e)
        {
            FrameworkDispatcher.Update();
        }

        #endregion
    }
}