﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
//using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Navigation;

using Microsoft.Phone.Controls;

using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input.Touch;
using Microsoft.Xna.Framework.Media;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Input;

using WindowsGame1;
using WindowsGame1.Umetna_inteligenca;

using System.Windows.Media.Imaging;
using System.IO;
using System.IO.IsolatedStorage;

namespace SlXnaApp1
{
    public partial class GamePage : PhoneApplicationPage
    {
        #region lokalne globalne spremenljivke
        ContentManager contentManager;
        GameTimer timer;
        SpriteBatch spriteBatch;
        VertexPositionColor[] verteksiPolj;
        VertexPositionColor[] verteksiCrt;
        List<float> kolicinaSence;
        List<Color> barveSenc;
        BasicEffect mojEffect;

        UIElementRenderer meniji;
        List<Button> seznamGumbov;
        fazaIgre prejsnaFaza;
        int prejsnoPolje, steviloGumbov = 5;

        Igra trenutnaIgra;
        Texture2D dumyTexture;
        Color a;
        bool spremembe;

        //risanje
        int stTrik = 0, stCrt = 0, stevec = -1, visina = 20, sumTrik = 0;
        float delta = 0.3f;

        #endregion

        public double distance(Microsoft.Xna.Framework.Point a, Microsoft.Xna.Framework.Point b)
        {
            double D = Math.Pow((double)b.X - a.X, 2) + Math.Pow((double)b.Y - a.Y, 2);
            return Math.Abs(D);
        }

        public GamePage()
        {
            InitializeComponent();

            // Get the content manager from the application
            contentManager = (System.Windows.Application.Current as App).Content;

            txtBox.Visibility = System.Windows.Visibility.Visible;
            btndrzave.IsEnabled = true;
            btndrzave.Visibility = System.Windows.Visibility.Visible;
            btnKonec.IsEnabled = true;
            btnKonec.Visibility = System.Windows.Visibility.Collapsed;
            imageDesno.Visibility = System.Windows.Visibility.Visible;

            // Create a timer for this page
            timer = new GameTimer();
            timer.UpdateInterval = TimeSpan.FromTicks(333333);
            timer.Update += OnUpdate;
            timer.Draw += OnDraw;
        }

        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
            // Set the sharing mode of the graphics device to turn on XNA rendering

            trenutnaIgra = new Igra();
            SharedGraphicsDeviceManager.Current.GraphicsDevice.SetSharingMode(true);

            if ((App.Current as App).spremembe)
            {
                trenutnaIgra = new Igra((App.Current as App).nasaIgra.mapa, (App.Current as App).playeri, 3);
                (App.Current as App).spremembe = false;
            }
            else
            {
                try
                {
                    trenutnaIgra = trenutnaIgra.DeSerialize<Igra>("neki");
                }
                catch (Exception)
                {
                    trenutnaIgra = new Igra((App.Current as App).nasaIgra.mapa, (App.Current as App).playeri, 3);
                }
                
            }
            
            spriteBatch = new SpriteBatch(SharedGraphicsDeviceManager.Current.GraphicsDevice);
            meniji = new UIElementRenderer(LayoutRoot, SharedGraphicsDeviceManager.Current.GraphicsDevice.Viewport.Width,
                                                        SharedGraphicsDeviceManager.Current.GraphicsDevice.Viewport.Height);

            #region inicializacija spremenljivk
            dumyTexture = new Texture2D(SharedGraphicsDeviceManager.Current.GraphicsDevice, 1, 1);
            dumyTexture.SetData(new Color[] { Color.White });

            a = Color.White;

            txtBox.Text = "Na potezi:\n " + trenutnaIgra.igralci[trenutnaIgra.naPotezi].ime + "\n\nFaza:\n Okrepitve\n\nPostavi še\n " + trenutnaIgra.igralci[trenutnaIgra.naPotezi].naZalogi;
            prejsnoPolje = -1;
            //trenutnaIgra.faza = fazaIgre.okrepitve;
            spremembe = true;

            #region postavitev gumbov

            int velikost = 70, velPol = velikost / 2;
            seznamGumbov = new List<Button>();
            for (int i = 0; i < trenutnaIgra.mapa.polja.Count; i++)
            {
                seznamGumbov.Add(new Button());
                a = trenutnaIgra.igralci[trenutnaIgra.mapa.polja[i].indexLastnika].barva;
                seznamGumbov[i].BorderThickness = new System.Windows.Thickness(0);
                seznamGumbov[i].Foreground = new System.Windows.Media.SolidColorBrush(System.Windows.Media.Color.FromArgb(255, 0, 0, 0));
                seznamGumbov[i].Background = new System.Windows.Media.RadialGradientBrush(System.Windows.Media.Color.FromArgb(100, a.R, a.G, a.B), System.Windows.Media.Color.FromArgb(0, a.R, a.G, a.B));
                seznamGumbov[i].Margin = new System.Windows.Thickness(trenutnaIgra.mapa.polja[i].sredina.X - velPol,
                                                                      trenutnaIgra.mapa.polja[i].sredina.Y - velPol,
                                                                      800 - trenutnaIgra.mapa.polja[i].sredina.X - velPol,
                                                                      480 - trenutnaIgra.mapa.polja[i].sredina.Y - velPol);
                seznamGumbov[i].Content = trenutnaIgra.mapa.polja[i].steviloVojakov.ToString();
                seznamGumbov[i].Width = velikost;
                seznamGumbov[i].Height = velikost;
                seznamGumbov[i].FontSize = 20;
                seznamGumbov[i].Tag = i.ToString();
                //seznamGumbov[i].Style = (System.Windows.Style)this.Resources["butec"];
                seznamGumbov[i].Click += new System.Windows.RoutedEventHandler(poljeKliknjeno);

                LayoutRoot.Children.Add(seznamGumbov[i]);
            }/**/
            #endregion

            verteksiPolj = new VertexPositionColor[1000];
            verteksiCrt = new VertexPositionColor[10000];
            //za 3d prikaz
            mojEffect = new BasicEffect(SharedGraphicsDeviceManager.Current.GraphicsDevice);
            mojEffect.World = Matrix.Identity;
            mojEffect.View = Matrix.CreateLookAt(new Vector3(400, 600, 240), new Vector3(400, 20, 240), new Vector3(0, 0, -1));
            mojEffect.Projection = Matrix.CreatePerspectiveFieldOfView(MathHelper.PiOver4, SharedGraphicsDeviceManager.Current.GraphicsDevice.Viewport.AspectRatio, 0.1f, 10000.0f);
            mojEffect.VertexColorEnabled = true;

            // Start the timer
            
            shading();
            RisiPolje();
            risiCrte();
            timer.Start();
            #endregion

            
            base.OnNavigatedTo(e);
        }

        protected override void OnNavigatedFrom(NavigationEventArgs e)
        {
            // Stop the timer
            timer.Stop();

            // Set the sharing mode of the graphics device to turn off XNA rendering
            SharedGraphicsDeviceManager.Current.GraphicsDevice.SetSharingMode(false);
            trenutnaIgra.Serialize<Igra>(trenutnaIgra, "neki");

            base.OnNavigatedFrom(e);
        }

        /// <summary>
        /// Allows the page to run logic such as updating the world,
        /// checking for collisions, gathering input, and playing audio.
        /// </summary>
        private void OnUpdate(object sender, GameTimerEventArgs e)
        {
            TouchCollection touchCollection = TouchPanel.GetState();

            if (spremembe)
            {
                posodobi();
                spremembe = false;
            }

            Racunalnik();
        }

        /// <summary>
        /// Allows the page to draw itself.
        /// </summary>
        private void OnDraw(object sender, GameTimerEventArgs e)
        {
            SharedGraphicsDeviceManager.Current.GraphicsDevice.Clear(Color.Black);

            SharedGraphicsDeviceManager.Current.GraphicsDevice.DepthStencilState = DepthStencilState.Default;
            SharedGraphicsDeviceManager.Current.GraphicsDevice.BlendState = BlendState.Opaque;

            /*RasterizerState neki = new RasterizerState()
            {
                FillMode = FillMode.WireFrame,
                CullMode = CullMode.None,
            };
            SharedGraphicsDeviceManager.Current.GraphicsDevice.RasterizerState = neki;/**/

            //riasnje polja
            mojEffect.CurrentTechnique.Passes[0].Apply();
            for (int i = 0; i < stTrik; i += 20)
            {
                SharedGraphicsDeviceManager.Current.GraphicsDevice.DrawUserPrimitives<VertexPositionColor>(PrimitiveType.TriangleList, verteksiPolj, i * 3, 20);
            }

            //risem crte
            mojEffect.CurrentTechnique.Passes[0].Apply();
            for (int i = 0; i < stCrt; i += 20)
            {
                SharedGraphicsDeviceManager.Current.GraphicsDevice.DrawUserPrimitives<VertexPositionColor>(PrimitiveType.LineList, verteksiCrt, i * 2, 20);
            }


            spriteBatch.Begin();
            meniji.Render();
            spriteBatch.Draw(meniji.Texture, Vector2.Zero, Color.White);
            spriteBatch.End();
        }

        /// <summary>
        /// drzave
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button1_Click(object sender, System.Windows.RoutedEventArgs e)
        {
            if (btndrzave.Content.ToString() == "Države")
            {
                prejsnaFaza = trenutnaIgra.faza;
                btnKonec.Visibility = System.Windows.Visibility.Collapsed;
                trenutnaIgra.faza = fazaIgre.drzave;
                btndrzave.Content = "Nazaj";
                RisiDrzave();
            }
            else
            {
                btndrzave.Content = "Države";
                trenutnaIgra.faza = prejsnaFaza;
                RisiPolje();
                switch (trenutnaIgra.faza)
                {
                    case fazaIgre.napadanje:
                    case fazaIgre.fortifikacija:
                        btnKonec.Visibility = System.Windows.Visibility.Visible;
                        break;
                    default:
                        break;
                }

            }
        }

        /// <summary>
        /// premikanje po fazah
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnKonecNapada(object sender, System.Windows.RoutedEventArgs e)
        {
            spremembe = true;
            string besedilo = "Konec\n ";
            btnKonec.Visibility = System.Windows.Visibility.Visible;
            switch (trenutnaIgra.faza)
            {
                case fazaIgre.okrepitve:
                    btnKonec.Visibility = System.Windows.Visibility.Collapsed;
                    txtBox.Text = "Na potezi:\n " + trenutnaIgra.igralci[trenutnaIgra.naPotezi].ime + "\n\nFaza:\n Okrepitve\n\nPostavi še:\n " + trenutnaIgra.igralci[trenutnaIgra.naPotezi].naZalogi;
                    break;

                //konec poteze
                case fazaIgre.fortifikacija:
                    btnKonec.Visibility = System.Windows.Visibility.Collapsed;
                    besedilo += "Napada";
                    trenutnaIgra.faza = fazaIgre.okrepitve;
                    trenutnaIgra.koncajPotezo();
                    prejsnoPolje = -1;
                    posodobi();
                    Racunalnik();
                    txtBox.Text = "Na potezi:\n " + trenutnaIgra.igralci[trenutnaIgra.naPotezi].ime + "\n\nFaza:\n Okrepitve\n\nPostavi še:\n " + trenutnaIgra.igralci[trenutnaIgra.naPotezi].naZalogi;
                    break;

                //konec napadanja
                case fazaIgre.napadanje:
                    besedilo += "Poteze";
                    txtBox.Text = "Na potezi:\n " + trenutnaIgra.igralci[trenutnaIgra.naPotezi].ime + "\n\nFaza:\n Fortifikacija";
                    trenutnaIgra.faza = fazaIgre.fortifikacija;
                    trenutnaIgra.posodobiProizvodnjo();
                    prejsnoPolje = -1;
                    break;
                case fazaIgre.drzave:
                    break;
                default:
                    break;
            }

            btnKonec.Content = new TextBlock { Height = 64, Width = 113, Text = besedilo };
        }

        /// <summary>
        /// Handling knofov
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void poljeKliknjeno(object sender, System.Windows.RoutedEventArgs e)
        {
            spremembe = true;
            int index = Convert.ToInt32(((Button)sender).Tag);

            switch (trenutnaIgra.faza)
            {
                case fazaIgre.okrepitve:
                    {
                        trenutnaIgra.postaviVojaka(index, 1);

                        if (trenutnaIgra.igralci[trenutnaIgra.naPotezi].naZalogi == 0)
                        {
                            trenutnaIgra.faza = fazaIgre.napadanje;
                            btnKonec.Visibility = System.Windows.Visibility.Visible;
                            txtBox.Text = "Na potezi:\n " + trenutnaIgra.igralci[trenutnaIgra.naPotezi].ime + "\n\nFaza:\n Napadanje";
                        }
                        else
                        {
                            txtBox.Text = "Na potezi:\n " + trenutnaIgra.igralci[trenutnaIgra.naPotezi].ime + "\n\nFaza:\n Okrepitve\n\nPostavi še\n " + trenutnaIgra.igralci[trenutnaIgra.naPotezi].naZalogi;
                        }
                    }
                    break;
                case fazaIgre.napadanje:
                    {
                        a = trenutnaIgra.igralci[trenutnaIgra.naPotezi].barva;
                        if (trenutnaIgra.mapa.polja[index].indexLastnika == trenutnaIgra.naPotezi)
                        {
                            prejsnoPolje = index;
                        }
                        else if (prejsnoPolje != -1)
                        {
                            Zvok();
                            trenutnaIgra.napadi(prejsnoPolje, index);
                            
                            if (trenutnaIgra.mapa.polja[index].indexLastnika == trenutnaIgra.naPotezi)
                            {
                                prejsnoPolje = index;
                            }
                            if (trenutnaIgra.faza == fazaIgre.okrepitve)
                            {
                                zmagaPoraz();
                                RisiPolje();
                                btnKonec.Visibility = System.Windows.Visibility.Collapsed;
                                txtBox.Text = "Na potezi:\n " + trenutnaIgra.igralci[trenutnaIgra.naPotezi].ime + "\n\nFaza:\n Okrepitve\n\nPostavi še\n " + trenutnaIgra.igralci[trenutnaIgra.naPotezi].naZalogi;
                            }

                            zmagaPoraz();
                        }
                    }
                    break;
                case fazaIgre.fortifikacija:
                    {
                        if (prejsnoPolje != -1 && prejsnoPolje != index)
                        {
                            trenutnaIgra.premakniVojaka(prejsnoPolje, index, 1);
                            if (trenutnaIgra.mapa.polja[prejsnoPolje].steviloVojakov == 1)
                            {
                                prejsnoPolje = index;
                            }
                        }
                        else if (prejsnoPolje == index)
                        {
                            prejsnoPolje = -1;
                        }
                        else
                        {
                            prejsnoPolje = index;
                        }
                    }
                    break;
                case fazaIgre.drzave:
                    break;
                default:
                    break;
            }
        }

        private void Racunalnik()
        {
            if (trenutnaIgra.igralci[trenutnaIgra.naPotezi].tip == tipIgralca.racunalnik)
            {
                //Umetna_inteligenca.UI komp = new Umetna_inteligenca.UI(MojVmesnik.mojaIgra);
                UI komp = new UI(trenutnaIgra);
                komp.trenutnaIgra.posodobiProizvodnjo();
                spremembe = true;
                txtBox.Text = "Na potezi:\n " + trenutnaIgra.igralci[trenutnaIgra.naPotezi].ime + "\n\nFaza:\n Okrepitve\n\nPostavi še\n " + trenutnaIgra.igralci[trenutnaIgra.naPotezi].naZalogi;
                komp.FazaIgre_Okrepitve();
                spremembe = true;
                //MojVmesnik.mojaIgra = new Igra(komp.trenutnaIgra);
                txtBox.Text = "Na potezi:\n " + trenutnaIgra.igralci[trenutnaIgra.naPotezi].ime + "\n\nFaza:\n Napadanje";
                komp.FazaIgre_Napadanje();
                //komp.FazaIgre_Napadanje();
                //komp.FazaIgre_Napadanje();
                //komp.FazaIgre_Napadanje();
                //komp.FazaIgre_Napadanje();
                spremembe = true;
                txtBox.Text = "Na potezi:\n " + trenutnaIgra.igralci[trenutnaIgra.naPotezi].ime + "\n\nFaza:\n Fortifikacija";
                komp.FazaIgre_Fortifikacija();
                spremembe = true;
                trenutnaIgra = new Igra(komp.trenutnaIgra);
                //MojVmesnik.mojaIgra.naPotezi = (MojVmesnik.mojaIgra.naPotezi + 1) % (MojVmesnik.mojaIgra.igralci.Count);
                trenutnaIgra.koncajPotezo();
                spremembe = true;
                txtBox.Text = "Na potezi:\n " + trenutnaIgra.igralci[trenutnaIgra.naPotezi].ime + "\n\nFaza:\n Okrepitve\n\nPostavi še:\n " + trenutnaIgra.igralci[trenutnaIgra.naPotezi].naZalogi;
                zmagaPoraz();
                RisiPolje();
            }
        }

        private void Nalagam()
        {
            System.Windows.Media.ImageBrush test = new System.Windows.Media.ImageBrush();
            test.ImageSource = new BitmapImage(new Uri("Slike/Loading.jpg", UriKind.Relative));
            LayoutRoot.Background = test;

            var store = IsolatedStorageFile.GetUserStoreForApplication();
            if (store.FileExists("neki"))
            {
                store.DeleteFile("neki");
            }

            for (int i = 0; i < trenutnaIgra.mapa.polja.Count; i++)
            {
                ((Button)LayoutRoot.Children[i + steviloGumbov]).Visibility = System.Windows.Visibility.Collapsed;
                ((Button)LayoutRoot.Children[i + steviloGumbov]).IsEnabled = false;
            }

            txtBox.Visibility = System.Windows.Visibility.Collapsed;
            btndrzave.IsEnabled = false;
            btndrzave.Visibility = System.Windows.Visibility.Collapsed;
            btnKonec.IsEnabled = false;
            btnKonec.Visibility = System.Windows.Visibility.Collapsed;
            imageDesno.Visibility = System.Windows.Visibility.Collapsed;

            LayoutRoot.UpdateLayout();
        }

        private void zmagaPoraz()
        {
            int c = 0;
            for (int i = 0; i < trenutnaIgra.igralci.Count; i++)
            {
                if (trenutnaIgra.igralci[i].tip == tipIgralca.clovek)
                    c++;
            }

            if (c == 0)
            {
                spremembe = false;
                Nalagam();
                //zgubu je
                (App.Current as App).jeZmagovalec = trenutnaIgra.naPotezi;
                (App.Current as App).spremembe = true;
                NavigationService.Navigate(new Uri("/KonecIgre.xaml", UriKind.Relative));
            }
            else if (c == 1 && trenutnaIgra.igralci.Count == 1)
            {
                spremembe = false;
                Nalagam();
                //en igralec je zmagu
                (App.Current as App).jeZmagovalec = trenutnaIgra.naPotezi;
                (App.Current as App).spremembe = true;
                NavigationService.Navigate(new Uri("/KonecIgre.xaml", UriKind.Relative));
            }
        }

        public void RisiPolje()
        {
            //TODO shader
            stevec = -1;
            visina = 20;
            sumTrik = 0;

            for (int i = 0; i < trenutnaIgra.mapa.polja.Count; i++)
            {
                stTrik = trenutnaIgra.mapa.polja[i].robneTocke.Count;
                sumTrik += stTrik;
                for (int j = 0; j < stTrik; j++)
                {
                    verteksiPolj[++stevec] = new VertexPositionColor(new Vector3(trenutnaIgra.mapa.polja[i].robneTocke[j % stTrik].X, 0, trenutnaIgra.mapa.polja[i].robneTocke[j % stTrik].Y),
                                                                Color.Lerp(trenutnaIgra.igralci[trenutnaIgra.mapa.polja[i].indexLastnika].barva, barveSenc[stevec], kolicinaSence[stevec]));
                    verteksiPolj[++stevec] = new VertexPositionColor(new Vector3(trenutnaIgra.mapa.polja[i].robneTocke[(j + 1) % stTrik].X, 0, trenutnaIgra.mapa.polja[i].robneTocke[(j + 1) % stTrik].Y),
                                                                Color.Lerp(trenutnaIgra.igralci[trenutnaIgra.mapa.polja[i].indexLastnika].barva, barveSenc[stevec], kolicinaSence[stevec]));
                    verteksiPolj[++stevec] = new VertexPositionColor(new Vector3(trenutnaIgra.mapa.polja[i].sredina.X, visina, trenutnaIgra.mapa.polja[i].sredina.Y),
                                                                Color.Lerp(trenutnaIgra.igralci[trenutnaIgra.mapa.polja[i].indexLastnika].barva, Color.White, 0.4f));
                }
            }
            stTrik = sumTrik;
        }

        public void RisiDrzave()
        {
            //TODO shader
            stevec = -1;
            visina = 20;
            sumTrik = 0;

            Color[] barve = new Color[7];
            float a = 0.5f;
            barve[0] = Color.Red;
            barve[1] = Color.Green;
            barve[2] = Color.Blue;
            barve[3] = Color.Silver;
            barve[4] = Color.LawnGreen;
            barve[5] = Color.Pink;
            barve[6] = Color.Orange;

            for (int i = 0; i < trenutnaIgra.mapa.polja.Count; i++)
            {
                stTrik = trenutnaIgra.mapa.polja[i].robneTocke.Count;
                sumTrik += stTrik;
                for (int j = 0; j < stTrik; j++)
                {
                    verteksiPolj[++stevec] = new VertexPositionColor(new Vector3(trenutnaIgra.mapa.polja[i].robneTocke[j % stTrik].X, 0, trenutnaIgra.mapa.polja[i].robneTocke[j % stTrik].Y),
                                                                Color.Lerp(barve[trenutnaIgra.mapa.polja[i].skupina % 7], barveSenc[stevec], kolicinaSence[stevec]));
                    verteksiPolj[++stevec] = new VertexPositionColor(new Vector3(trenutnaIgra.mapa.polja[i].robneTocke[(j + 1) % stTrik].X, 0, trenutnaIgra.mapa.polja[i].robneTocke[(j + 1) % stTrik].Y),
                                                               Color.Lerp(barve[trenutnaIgra.mapa.polja[i].skupina % 7], barveSenc[stevec], kolicinaSence[stevec]));
                    verteksiPolj[++stevec] = new VertexPositionColor(new Vector3(trenutnaIgra.mapa.polja[i].sredina.X, visina, trenutnaIgra.mapa.polja[i].sredina.Y),
                                                                Color.Lerp(barve[trenutnaIgra.mapa.polja[i].skupina % 7], Color.White, 0.25f));
                }
            }
            stTrik = sumTrik;
        }

        public void risiCrte()
        {
            Point a = new Point(), b = new Point();
            int sumCrt;
            visina = 12; stevec = -1;
            stCrt = 0;
            for (int i = 0; i < trenutnaIgra.mapa.polja.Count; i++)
            {
                sumCrt = trenutnaIgra.mapa.polja[i].indexSoseda.Count;
                stCrt += sumCrt * 5;
                for (int j = 0; j < sumCrt; j++)
                {
                    a.X = trenutnaIgra.mapa.polja[i].sredina.X; a.Y = trenutnaIgra.mapa.polja[i].sredina.Y;
                    b.X = trenutnaIgra.mapa.polja[trenutnaIgra.mapa.polja[i].indexSoseda[j]].sredina.X;
                    b.Y = trenutnaIgra.mapa.polja[trenutnaIgra.mapa.polja[i].indexSoseda[j]].sredina.Y;
                    verteksiCrt[++stevec] = new VertexPositionColor(new Vector3(a.X, visina, a.Y), Color.Black);
                    verteksiCrt[++stevec] = new VertexPositionColor(new Vector3(b.X, visina, b.Y), Color.Black);

                    verteksiCrt[++stevec] = new VertexPositionColor(new Vector3(a.X + delta, visina, a.Y + delta), Color.Black);
                    verteksiCrt[++stevec] = new VertexPositionColor(new Vector3(b.X + delta, visina, b.Y + delta), Color.Black);

                    verteksiCrt[++stevec] = new VertexPositionColor(new Vector3(a.X - delta, visina, a.Y - delta), Color.Black);
                    verteksiCrt[++stevec] = new VertexPositionColor(new Vector3(b.X - delta, visina, b.Y - delta), Color.Black);

                    verteksiCrt[++stevec] = new VertexPositionColor(new Vector3(a.X + delta, visina, a.Y - delta), Color.Black);
                    verteksiCrt[++stevec] = new VertexPositionColor(new Vector3(b.X + delta, visina, b.Y - delta), Color.Black);

                    verteksiCrt[++stevec] = new VertexPositionColor(new Vector3(a.X - delta, visina, a.Y + delta), Color.Black);
                    verteksiCrt[++stevec] = new VertexPositionColor(new Vector3(b.X - delta, visina, b.Y + delta), Color.Black);
                }
            }
        }

        public void posodobi()
        {
            Color n;

            //resetiram vse kot da ni nobeden izbran
            for (int i = 0; i < trenutnaIgra.mapa.polja.Count; i++)
            {
                n = trenutnaIgra.igralci[trenutnaIgra.mapa.polja[i].indexLastnika].barva;
                ((Button)LayoutRoot.Children[i + steviloGumbov]).Background = new System.Windows.Media.RadialGradientBrush(System.Windows.Media.Color.FromArgb(100, n.R, n.G, n.B), System.Windows.Media.Color.FromArgb(0, n.R, n.G, n.B));
                ((Button)LayoutRoot.Children[i + steviloGumbov]).BorderThickness = new System.Windows.Thickness(0);
                ((Button)LayoutRoot.Children[i + steviloGumbov]).BorderBrush = new System.Windows.Media.SolidColorBrush(System.Windows.Media.Color.FromArgb(0, 0, 0, 0));
                ((Button)LayoutRoot.Children[i + steviloGumbov]).FontSize = 20;
                ((Button)LayoutRoot.Children[i + steviloGumbov]).Content = trenutnaIgra.mapa.polja[i].steviloVojakov.ToString();
                ((Button)LayoutRoot.Children[i + steviloGumbov]).Visibility = System.Windows.Visibility.Visible;
                ((Button)LayoutRoot.Children[i + steviloGumbov]).IsEnabled = true;
            }

            if (prejsnoPolje != -1)
            {
                n = trenutnaIgra.igralci[trenutnaIgra.mapa.polja[prejsnoPolje].indexLastnika].barva;
                ((Button)LayoutRoot.Children[prejsnoPolje + steviloGumbov]).Background = new System.Windows.Media.RadialGradientBrush(System.Windows.Media.Color.FromArgb(100, n.R, n.G, n.B), System.Windows.Media.Color.FromArgb(50, 0, 255, 0));

                foreach (int item in trenutnaIgra.mapa.polja[prejsnoPolje].indexSoseda)
                {
                    n = trenutnaIgra.igralci[trenutnaIgra.mapa.polja[item].indexLastnika].barva;
                    if (trenutnaIgra.mapa.polja[item].indexLastnika != trenutnaIgra.naPotezi && trenutnaIgra.faza == fazaIgre.napadanje)
                    {
                        ((Button)LayoutRoot.Children[item + steviloGumbov]).BorderThickness = new System.Windows.Thickness(2);
                        ((Button)LayoutRoot.Children[item + steviloGumbov]).BorderBrush = new System.Windows.Media.SolidColorBrush(System.Windows.Media.Color.FromArgb(255, 255, 0, 0));
                        ((Button)LayoutRoot.Children[item + steviloGumbov]).Background = new System.Windows.Media.RadialGradientBrush(System.Windows.Media.Color.FromArgb(100, n.R, n.G, n.B), System.Windows.Media.Color.FromArgb(50, 255, 0, 0));
                        ((Button)LayoutRoot.Children[item + steviloGumbov]).FontSize = 22;

                    }
                    else if (trenutnaIgra.mapa.polja[item].indexLastnika == trenutnaIgra.naPotezi && trenutnaIgra.faza == fazaIgre.fortifikacija)
                    {
                        ((Button)LayoutRoot.Children[item + steviloGumbov]).BorderThickness = new System.Windows.Thickness(2);
                        ((Button)LayoutRoot.Children[item + steviloGumbov]).BorderBrush = new System.Windows.Media.SolidColorBrush(System.Windows.Media.Color.FromArgb(255, 0, 255, 0));
                        ((Button)LayoutRoot.Children[item + steviloGumbov]).Background = new System.Windows.Media.RadialGradientBrush(System.Windows.Media.Color.FromArgb(100, 255, n.G, n.B), System.Windows.Media.Color.FromArgb(20, 0, 0, 255));
                        ((Button)LayoutRoot.Children[item + steviloGumbov]).FontSize = 22;
                    }
                }
            }

            if (trenutnaIgra.faza != fazaIgre.okrepitve)
            {
                RisiPolje();
            }
        }

        public void shading()
        {
            Color barvaSvetlobe = Color.White;
            Color barvaSence = Color.Black;
            float kolicina;

            Vektor3 izvor = new Vektor3 (0, 20, 500), smer = new Vektor3(800,10,0);
            Vektor3 trenutni, center, naslednji, prejsni;


            //double a = Vektor3.DotProduct(Vektor3.Normalize(Vektor3.CrossProduct(trenutni - naslednji, trenutni - center)), Vektor3.Normalize(izvor - smer));

            barveSenc = new List<Color>();
            kolicinaSence = new List<float>();

            for (int i = 0; i < trenutnaIgra.mapa.polja.Count; i++)
            {
                for (int j = 0; j < trenutnaIgra.mapa.polja[i].robneTocke.Count; j++)
                {

                    trenutni = new Vektor3(trenutnaIgra.mapa.polja[i].robneTocke[j].X, trenutnaIgra.mapa.polja[i].robneTocke[j].Y, 0);
                    naslednji = new Vektor3(trenutnaIgra.mapa.polja[i].robneTocke[(j + 1) % trenutnaIgra.mapa.polja[i].robneTocke.Count].X,
                                            trenutnaIgra.mapa.polja[i].robneTocke[(j + 1) % trenutnaIgra.mapa.polja[i].robneTocke.Count].Y, 0);
                    prejsni = new Vektor3(trenutnaIgra.mapa.polja[i].robneTocke[(j + trenutnaIgra.mapa.polja[i].robneTocke.Count - 1) % trenutnaIgra.mapa.polja[i].robneTocke.Count].X,
                                          trenutnaIgra.mapa.polja[i].robneTocke[(j + trenutnaIgra.mapa.polja[i].robneTocke.Count - 1) % trenutnaIgra.mapa.polja[i].robneTocke.Count].Y, 0);
                    center = new Vektor3(trenutnaIgra.mapa.polja[i].sredina.X, trenutnaIgra.mapa.polja[i].sredina.Y, visina);

                    
                    kolicina = (float) Vektor3.DotProduct(Vektor3.Normalize(Vektor3.CrossProduct(trenutni - naslednji, trenutni - center)), Vektor3.Normalize(izvor - smer));
                    barveSenc.Add(barvaSence);
                    kolicinaSence.Add(kolicina * 1.4f);
                    //kolicinaSence.Add(0);


                    prejsni = trenutni;
                    trenutni = naslednji;
                    naslednji = new Vektor3(trenutnaIgra.mapa.polja[i].robneTocke[(j + 2) % trenutnaIgra.mapa.polja[i].robneTocke.Count].X,
                                            trenutnaIgra.mapa.polja[i].robneTocke[(j + 2) % trenutnaIgra.mapa.polja[i].robneTocke.Count].Y, 0);

                    kolicina = (float)Vektor3.DotProduct(Vektor3.Normalize(Vektor3.CrossProduct(trenutni - naslednji, trenutni - center)), Vektor3.Normalize(izvor - smer));
                    barveSenc.Add(barvaSence);
                    kolicinaSence.Add(kolicina * 1.4f);
                    //kolicinaSence.Add(0);

                    barveSenc.Add(barvaSvetlobe);
                    kolicinaSence.Add(0.0f);
                }
            }
        }

        private void Zvok()
        {
            if ((App.Current as App).zvok)
                bomba.Play();
        }
    }
}