﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using System.Windows.Media.Imaging;

namespace SlXnaApp1
{
    public partial class MainPage : PhoneApplicationPage
    {
        // Constructor
        public MainPage()
        {
            InitializeComponent();
            
            PreveriZvok();
        }

        ImageBrush brush;

        // Simple button Click event handler to take us to the second page
        private void btnNaloziMapo_Click(object sender, RoutedEventArgs e)
        {
            NavigationService.Navigate(new Uri("/NaloziMapo.xaml", UriKind.Relative));
        }

        private void btnIzhod_Click(object sender, RoutedEventArgs e)
        {
            intro.Stop();
            Microsoft.Xna.Framework.Game game = new Microsoft.Xna.Framework.Game();
            game.Exit();
        }

        private void btnZazeniIgro_Click(object sender, RoutedEventArgs e)
        {
            if (((App.Current as App).trenutnaMapa == 2) && (!(App.Current as App).zajetaSlika))
            {
                (App.Current as App).napaka = "Izbrali ste generirano mapo iz zajete slike,\nvendar niste zajeli oziroma razpoznali le te.";
                NavigationService.Navigate(new Uri("/Napaka.xaml", UriKind.Relative));
            }
            else
            {
                NavigationService.Navigate(new Uri("/GamePage.xaml", UriKind.Relative));
            }
        }

        private void btnIgralci_Click(object sender, RoutedEventArgs e)
        {
            NavigationService.Navigate(new Uri("/Nastavitve_Igralci.xaml", UriKind.Relative));
            (App.Current as App).spremembe = true;
        }

        private void btnMapa_Click(object sender, RoutedEventArgs e)
        {
            (App.Current as App).spremembe = true;
            NavigationService.Navigate(new Uri("/Nastavitve_Mapa.xaml", UriKind.Relative));
        }

        // Počistimo sklad -> Strani, ki so za ciklane, če klikamo back, kako bomo skakali
        protected override void OnNavigatedTo(System.Windows.Navigation.NavigationEventArgs e)
        {
            while (this.NavigationService.BackStack.Any())
            {
                this.NavigationService.RemoveBackEntry();
            }
        }

        // Če kliknemo back button, se ne zgodi nič! :)
        protected override void OnBackKeyPress(System.ComponentModel.CancelEventArgs e)
        {
            e.Cancel = true;
        }

        private void btnRezultat_Click(object sender, RoutedEventArgs e)
        {
            NavigationService.Navigate(new Uri("/Rezultat.xaml", UriKind.Relative));
        }

        private void btnZvok_Click(object sender, RoutedEventArgs e)
        {
            if ((App.Current as App).zvok)
            {
                (App.Current as App).zvok = false;
                (App.Current as App).pause = false;
            }
            else
                (App.Current as App).zvok = true;

            PreveriZvok();
        }

        private void PreveriZvok()
        {
            if ((App.Current as App).zvok)
            {
                brush = new ImageBrush();
                brush.ImageSource = new BitmapImage(new Uri("Slike/SoundON.png", UriKind.Relative));
                btnZvok.Background = brush;
                intro.Play();
                intro.IsMuted = false;
                (App.Current as App).pause = false;
            }
            else
            {
                brush = new ImageBrush();
                brush.ImageSource = new BitmapImage(new Uri("Slike/SoundOFF.png", UriKind.Relative));
                btnZvok.Background = brush;

                if (!(App.Current as App).pause)
                    intro.Pause();

                intro.IsMuted = true;
                (App.Current as App).pause = true;
            }
        }

        private void btnPomoc_Click(object sender, RoutedEventArgs e)
        {
            NavigationService.Navigate(new Uri("/Pomoc.xaml", UriKind.Relative));
        }
    }
}