﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using System.Windows.Resources;
using System.Windows.Media.Imaging;
using Microsoft.Phone;
using System.Collections.ObjectModel;
using Microsoft.Xna.Framework.Media;
using System.Text;
using System.IO;
using System.ComponentModel;
using System.Data;
using System.Threading;
using System.Diagnostics;
using System.IO.IsolatedStorage;

public class DCT
{
    // * Spremenljivke *
    public Color barva;
    public WriteableBitmap slika; // objekt slika
    public WriteableBitmap kompresija; // objekt slika
    private int tmpVelikost;
    short sirina;
    short visina;
    const byte N = 8;
    public List<byte> kodiranaSlika;
    static double[,] cos;
    static double vrednost;
    public List<byte> mojiPodatki;

    double C(byte x)
    {
        if (x == 0)
            return vrednost;
        return 1;
    }

    #region DCT

    void DodajBite(int stBitov, int vrednost, List<byte> buffer)
    {
        int calc = 0;

        while (--stBitov >= 0)
        {
            calc = 1 << stBitov;

            if ((vrednost - calc) >= 0)
            {
                buffer.Add((byte)1);
                vrednost = vrednost - calc;
            }
            else
                buffer.Add((byte)0);
        }
    }

    void DodajBit(byte vrednost, List<byte> buffer)
    {
        buffer.Add(vrednost);
    }

    byte DobiSteviloBitov(int vrednost)
    {
        byte stBitov = 0;
        if (vrednost > 128)
        {
            if (256 > vrednost)
            {
                stBitov = 8;
                goto KONEC;
            }
            if (512 > vrednost)
            {
                stBitov = 9;
                goto KONEC;
            }
            if (1024 > vrednost)
            {
                stBitov = 10;
                goto KONEC;
            }
            if (2048 > vrednost)
            {
                stBitov = 11;
                goto KONEC;
            }
            if (4096 > vrednost)
            {
                stBitov = 12;
                goto KONEC;
            }
        }
        else
        {
            if (2 > vrednost)
            {
                stBitov = 1;
                goto KONEC;
            }

            if (4 > vrednost)
            {
                stBitov = 2;
                goto KONEC;
            }

            if (8 > vrednost)
            {
                stBitov = 3;
                goto KONEC;
            }

            if (16 > vrednost)
            {
                stBitov = 4;
                goto KONEC;
            }

            if (32 > vrednost)
            {
                stBitov = 5;
                goto KONEC;
            }

            if (64 > vrednost)
            {
                stBitov = 6;
                goto KONEC;
            }

            if (128 > vrednost)
            {
                stBitov = 7;
                goto KONEC;
            }
        }
    KONEC:
        return stBitov;
    }

    void Kodiranje(short[] sekvenca, List<byte> mainBuffer)
    {
        int stBitov = 0;

        // DC člen
        if (sekvenca[0] > 0)
            this.DodajBit(1, mainBuffer);
        else
            this.DodajBit(0, mainBuffer);

        int tmp = Math.Abs(sekvenca[0]);
        this.DodajBite(10, tmp, mainBuffer);
        int i = 1;
        int zacetek = 0;

        while (i < 64)
        {
            if (sekvenca[i] == 0)
            {
                // b situacija
                this.DodajBit(0, mainBuffer);
                zacetek = i++;
                while (i + 1 < 64 && sekvenca[i] == 0)
                    i++;
                this.DodajBite(6, i - zacetek, mainBuffer); // tekoca dolzina za 0

                if ((i + 1) >= 64)
                    break;

                // a situacija
                tmp = Math.Abs(sekvenca[i]);
                stBitov = this.DobiSteviloBitov(tmp);
                this.DodajBite(4, stBitov, mainBuffer);

                if (sekvenca[i] > 0) // Predznak
                    this.DodajBit(1, mainBuffer);
                else
                    this.DodajBit(0, mainBuffer);
                this.DodajBite(stBitov, tmp, mainBuffer);
            }
            else
            {
                // c situacija
                this.DodajBit(1, mainBuffer); // fiksno

                tmp = Math.Abs(sekvenca[i]);
                stBitov = this.DobiSteviloBitov(tmp);
                this.DodajBite(4, stBitov, mainBuffer);

                if (sekvenca[i] > 0) // predznak
                    this.DodajBit(1, mainBuffer);
                else
                    this.DodajBit(0, mainBuffer);
                this.DodajBite(stBitov, tmp, mainBuffer);
            }
            i++;
        }
    }

    short F(byte u, byte v, byte[] blok)
    {
        double vsota = 0;
        int index = (v * N) + u;

        for (int j = 0; j < 64; j++)
        {
            if (blok[j] > 0)
                vsota = vsota + ((double)blok[j] * cos[index, j]);
        }
        vsota = (0.25 * C(u) * C(v) * vsota);

        if (Math.Abs(vsota) > 30)
            return (short)vsota;
        else
            return 0;
    }

    void DCT_Blok(byte[] I, short[] O)
    {
        // Stopnja 15
        O[0] = F(0, 0, I);
        // Stopnja 14
        O[1] = F(1, 0, I);
        O[2] = F(0, 1, I);
        // Stopnja 13
        O[3] = F(0, 2, I);
        O[4] = F(1, 1, I);
        O[5] = F(2, 0, I);
        // Stopnja 12
        O[6] = F(3, 0, I);
        O[7] = F(2, 1, I);
        O[8] = F(1, 2, I);
        O[9] = F(0, 3, I);
        // Stopnja 11
        O[10] = F(0, 4, I);
        O[11] = F(1, 3, I);
        O[12] = F(2, 2, I);
        O[13] = F(3, 1, I);
        O[14] = F(4, 0, I);
        // Stopnja 10
        O[15] = F(5, 0, I);
        O[16] = F(4, 1, I);
        O[17] = F(3, 2, I);
        O[18] = F(2, 3, I);
        O[19] = F(1, 4, I);
        O[20] = F(0, 5, I);
        /*
        // Stopnja 9
        O[21] = F(0, 6, I);
        O[22] = F(1, 5, I);
        O[23] = F(2, 4, I);
        O[24] = F(3, 3, I);
        O[25] = F(4, 2, I);
        O[26] = F(5, 1, I);
        O[27] = F(6, 0, I);
        // Stopnja 8
        O[28] = F(7, 0, I);
        O[29] = F(6, 1, I);
        O[30] = F(5, 2, I);
        O[31] = F(4, 3, I);
        O[32] = F(3, 4, I);
        O[33] = F(2, 5, I);
        O[34] = F(1, 6, I);
        O[35] = F(0, 7, I);
        // Stopnja 7
        O[36] = F(1, 7, I);
        O[37] = F(2, 6, I);
        O[38] = F(3, 5, I);
        O[39] = F(4, 4, I);
        O[40] = F(5, 3, I);
        O[41] = F(6, 2, I);
        O[42] = F(7, 1, I);
        // Stopnja 6
        O[43] = F(7, 2, I);
        O[44] = F(6, 3, I);
        O[45] = F(5, 4, I);
        O[46] = F(4, 5, I);
        O[47] = F(3, 6, I);
        O[48] = F(2, 7, I);
        // Stopnja 5
        O[49] = F(3, 7, I);
        O[50] = F(4, 6, I);
        O[51] = F(5, 5, I);
        O[52] = F(6, 4, I);
        O[53] = F(7, 3, I);
        // Stopnja 4
        O[54] = F(7, 4, I);
        O[55] = F(6, 5, I);
        O[56] = F(5, 6, I);
        O[57] = F(4, 7, I);
        // Stopnja 3
        O[58] = F(5, 7, I);
        O[59] = F(6, 6, I);
        O[60] = F(7, 5, I);
        // Stopnja 2
        O[61] = F(7, 6, I);
        O[62] = F(6, 7, I);
        // Stopnja 1
        O[63] = F(7, 7, I);
		*/

        /*
        for (int i = 28; i < 64; i++)
            O[i] = 0;
        */
    }

    List<byte> ZazeniDCT(byte[] I)
    {
        int vrstica = 0;
        int k = 0;
        int l = 0;
        int trenutnaVrstica = 0;

        int trenutniIndex;
        int index;
        byte[] blok = new byte[64];
        short[] sekvenca = new short[64];
        List<byte> stisnjeno = new List<byte>();
        for (int i = 0; i < visina; i += 8)
        {
            for (int j = 0; j < sirina; j += 8)
            {
                vrstica = (i * sirina) + j;
                trenutnaVrstica = 0;


                for (k = 0; k < N; k++)
                {
                    for (l = 0; l < N; l++)
                    {
                        trenutniIndex = trenutnaVrstica + l;
                        index = vrstica + l;
                        blok[trenutniIndex] = I[index];
                    }
                    trenutnaVrstica = trenutnaVrstica + N;
                    vrstica = vrstica + sirina;
                }

                DCT_Blok(blok, sekvenca);
                Kodiranje(sekvenca, stisnjeno);
            }
        }
        return stisnjeno;
    }

    private void Shranjevanje()
    {
        int bytes = this.kodiranaSlika.Count / 8;
        if ((this.kodiranaSlika.Count % 8) != 0) bytes++;

        byte[] array = new byte[bytes];

        int bitIndex = 0;
        int byteIndex = 0; // ni 0, če mi dodamo 5 bytov

        for (int i = 0; i < this.kodiranaSlika.Count; i++)
        {
            if (this.kodiranaSlika[i] == 1)
                array[byteIndex] |= (byte)(((byte)1) << bitIndex);

            bitIndex++;

            if (bitIndex == 8)
            {
                bitIndex = 0;
                byteIndex++;
            }
        }

        IsolatedStorageFile ISF = IsolatedStorageFile.GetUserStoreForApplication();
        BinaryWriter shraniBajteke = new BinaryWriter(new IsolatedStorageFileStream("hillWars.mul", FileMode.Create, FileAccess.Write, ISF));
        shraniBajteke.Write(array, 0, array.Length);
        shraniBajteke.Close();
    }

    public DCT(WriteableBitmap bitmap)
    {
        this.kompresija = new WriteableBitmap(bitmap.PixelWidth, bitmap.PixelHeight);

        sirina = (short)bitmap.PixelWidth;
        visina = (short)bitmap.PixelHeight;
        int velikost = sirina * visina;
        byte[] R = new byte[velikost];
        byte[] G = new byte[velikost];
        byte[] B = new byte[velikost];
        int stevec = 0;

        // Branje
        for (int i = 0; i < visina; i++)
        {
            for (int j = 0; j < sirina; j++)
            {
                this.barva = bitmap.GetPixel(j, i);
                R[stevec] = this.barva.R;
                G[stevec] = this.barva.G;
                B[stevec] = this.barva.B;

                stevec++;
            }
        }

        kodiranaSlika = new List<byte>();
        byte steviloBitov = DobiSteviloBitov(sirina);
        DodajBite(4, steviloBitov, kodiranaSlika);
        DodajBite(steviloBitov, sirina, kodiranaSlika);
        steviloBitov = DobiSteviloBitov(visina);
        DodajBite(4, steviloBitov, kodiranaSlika);
        DodajBite(steviloBitov, visina, kodiranaSlika);
        kodiranaSlika.AddRange(ZazeniDCT(R));
        kodiranaSlika.AddRange(ZazeniDCT(G));
        kodiranaSlika.AddRange(ZazeniDCT(B));

        this.Shranjevanje();
    }

    #endregion

    #region IDCT

    byte f(byte x, byte y, short[] blok)
    {
        double tmp = 0;
        byte index = (byte)(y * N + x);
        byte trenutniIndex = 0;

        for (byte i = 0; i < N; i++)
        {
            for (byte j = 0; j < N; j++)
            {
                if (blok[trenutniIndex] != 0)
                    tmp = tmp + C(i) * C(j) * (double)blok[trenutniIndex] * cos[trenutniIndex, index];

                trenutniIndex++;
            }
        }

        short cifra = (short)(0.25 * tmp);
        if (cifra > 255)
            return 255;
        else
        {
            if (tmp < 0)
                return 0;
            else
                return (byte)cifra;
        }
    }

    short DobiVrednostIzBuffra(sbyte stBitov, ref int index, List<byte> buffer)
    {
        short tmp = 0;

        while (--stBitov >= 0)
        {
            if (buffer[index++] == 1)
                tmp = (short)(tmp + (short)(1 << stBitov));
        }
        return tmp;
    }

    void DobiSekvenco(short[] O, ref int index, List<byte> podatki)
    {
        byte bit = podatki[index++];
        byte trenutniIndex = 0;
        sbyte stBitov = 0;
        short tmp = 0;
        tmp = DobiVrednostIzBuffra(10, ref index, podatki);

        if (bit == 0)
            tmp = (short)(-tmp);

        O[trenutniIndex++] = tmp;
        while (trenutniIndex < 63)
        {
            bit = (byte)DobiVrednostIzBuffra(1, ref index, podatki);
            if (bit == 0)
            {
                //B-situacija
                stBitov = (sbyte)DobiVrednostIzBuffra(6, ref index, podatki);
                while (--stBitov >= 0)
                    O[trenutniIndex++] = 0;
                if (trenutniIndex < 63)
                {
                    stBitov = (sbyte)DobiVrednostIzBuffra(4, ref index, podatki);
                    bit = (byte)DobiVrednostIzBuffra(1, ref index, podatki);
                    tmp = DobiVrednostIzBuffra(stBitov, ref index, podatki);
                    if (bit == 0)
                        tmp = (short)(-tmp);
                    O[trenutniIndex++] = tmp;
                }
            }
            else
            {
                //C-situacija
                stBitov = (sbyte)DobiVrednostIzBuffra(4, ref index, podatki);
                bit = (byte)DobiVrednostIzBuffra(1, ref index, podatki);
                tmp = DobiVrednostIzBuffra(stBitov, ref index, podatki);
                if (bit == 0)
                    tmp = (short)(-tmp);
                O[trenutniIndex++] = tmp;
            }
        }
    }

    void DobiBlok(short[] sekvenca, short[] blok)
    {
        blok[0] = sekvenca[0];

        blok[1] = sekvenca[1];
        blok[8] = sekvenca[2];

        blok[16] = sekvenca[3];
        blok[9] = sekvenca[4];
        blok[2] = sekvenca[5];

        blok[3] = sekvenca[6];
        blok[10] = sekvenca[7];
        blok[17] = sekvenca[8];
        blok[24] = sekvenca[9];

        blok[32] = sekvenca[10];
        blok[25] = sekvenca[11];
        blok[18] = sekvenca[12];
        blok[11] = sekvenca[13];
        blok[4] = sekvenca[14];

        blok[5] = sekvenca[15];
        blok[12] = sekvenca[16];
        blok[19] = sekvenca[17];
        blok[26] = sekvenca[18];
        blok[33] = sekvenca[19];
        blok[40] = sekvenca[20];
    }

    void PozicijaBloka(short X, short Y, byte[] podatki, short sirinaBlokca, byte[] blok)
    {
        int vrstica = Y * sirinaBlokca + X;
        podatki[vrstica + 0] = blok[0];
        podatki[vrstica + 1] = blok[1];
        podatki[vrstica + 2] = blok[2];
        podatki[vrstica + 3] = blok[3];
        podatki[vrstica + 4] = blok[4];
        podatki[vrstica + 5] = blok[5];
        podatki[vrstica + 6] = blok[6];
        podatki[vrstica + 7] = blok[7];
        vrstica = vrstica + sirinaBlokca;
        podatki[vrstica + 0] = blok[8];
        podatki[vrstica + 1] = blok[9];
        podatki[vrstica + 2] = blok[10];
        podatki[vrstica + 3] = blok[11];
        podatki[vrstica + 4] = blok[12];
        podatki[vrstica + 5] = blok[13];
        podatki[vrstica + 6] = blok[14];
        podatki[vrstica + 7] = blok[15];
        vrstica = vrstica + sirinaBlokca;
        podatki[vrstica + 0] = blok[16];
        podatki[vrstica + 1] = blok[17];
        podatki[vrstica + 2] = blok[18];
        podatki[vrstica + 3] = blok[19];
        podatki[vrstica + 4] = blok[20];
        podatki[vrstica + 5] = blok[21];
        podatki[vrstica + 6] = blok[22];
        podatki[vrstica + 7] = blok[23];
        vrstica = vrstica + sirinaBlokca;
        podatki[vrstica + 0] = blok[24];
        podatki[vrstica + 1] = blok[25];
        podatki[vrstica + 2] = blok[26];
        podatki[vrstica + 3] = blok[27];
        podatki[vrstica + 4] = blok[28];
        podatki[vrstica + 5] = blok[29];
        podatki[vrstica + 6] = blok[30];
        podatki[vrstica + 7] = blok[31];
        vrstica = vrstica + sirinaBlokca;
        podatki[vrstica + 0] = blok[32];
        podatki[vrstica + 1] = blok[33];
        podatki[vrstica + 2] = blok[34];
        podatki[vrstica + 3] = blok[35];
        podatki[vrstica + 4] = blok[36];
        podatki[vrstica + 5] = blok[37];
        podatki[vrstica + 6] = blok[38];
        podatki[vrstica + 7] = blok[39];
        vrstica = vrstica + sirinaBlokca;
        podatki[vrstica + 0] = blok[40];
        podatki[vrstica + 1] = blok[41];
        podatki[vrstica + 2] = blok[42];
        podatki[vrstica + 3] = blok[43];
        podatki[vrstica + 4] = blok[44];
        podatki[vrstica + 5] = blok[45];
        podatki[vrstica + 6] = blok[46];
        podatki[vrstica + 7] = blok[47];
        vrstica = vrstica + sirinaBlokca;
        podatki[vrstica + 0] = blok[48];
        podatki[vrstica + 1] = blok[49];
        podatki[vrstica + 2] = blok[50];
        podatki[vrstica + 3] = blok[51];
        podatki[vrstica + 4] = blok[52];
        podatki[vrstica + 5] = blok[53];
        podatki[vrstica + 6] = blok[54];
        podatki[vrstica + 7] = blok[55];
        vrstica = vrstica + sirinaBlokca;
        podatki[vrstica + 0] = blok[56];
        podatki[vrstica + 1] = blok[57];
        podatki[vrstica + 2] = blok[58];
        podatki[vrstica + 3] = blok[59];
        podatki[vrstica + 4] = blok[60];
        podatki[vrstica + 5] = blok[61];
        podatki[vrstica + 6] = blok[62];
        podatki[vrstica + 7] = blok[63];
    }

    void ZazeniIDCT(short[] tmpBlok, byte[] blok)
    {
        byte stevec = 0;

        for (byte i = 0; i < N; i++)
        {
            for (byte j = 0; j < N; j++)
                blok[stevec++] = f(j, i, tmpBlok);
        }
    }

    private void Branje()
    {
        IsolatedStorageFile ISF = IsolatedStorageFile.GetUserStoreForApplication();
        IsolatedStorageFileStream OdpriDatoteko = ISF.OpenFile("hillWars.mul", FileMode.Open, FileAccess.Read);
        byte[] buffer = new byte[OdpriDatoteko.Length];
        BinaryReader beriBajteke = new BinaryReader(OdpriDatoteko);
        beriBajteke.Read(buffer, 0, buffer.Length);
        beriBajteke.Close();

        bool[] bajtek = new bool[8];
        for (int i = 0; i < buffer.Length; i++)
        {
            this.tmpVelikost = 0;
            bajtek = this.DodajDolzino(bajtek, 8, (int)buffer[i]);
            this.tmpVelikost = 0;

            do
            {
                this.mojiPodatki.Add((bajtek[this.tmpVelikost++]) ? (byte)1 : (byte)0);
            } while (this.tmpVelikost < 8);
        }
    }

    private bool[] DodajDolzino(bool[] poljeBit, int velikost, int dolzina)
    {
        for (int j = 0; j < velikost; j++)
        {
            poljeBit[this.tmpVelikost] = Convert.ToBoolean(dolzina % 2);
            dolzina = dolzina >> 1;
            this.tmpVelikost++;
        }

        return poljeBit;
    }

    public DCT()
    {
        this.mojiPodatki = new List<byte>();
        this.Branje();

        int trenutniIndex = 0;
        sbyte stBitov = (sbyte)DobiVrednostIzBuffra(4, ref trenutniIndex, this.mojiPodatki);
        short tmp = DobiVrednostIzBuffra(stBitov, ref trenutniIndex, this.mojiPodatki);
        this.sirina = tmp;
        stBitov = (sbyte)DobiVrednostIzBuffra(4, ref trenutniIndex, this.mojiPodatki);
        tmp = DobiVrednostIzBuffra(stBitov, ref trenutniIndex, this.mojiPodatki);
        this.visina = tmp;

        int pixli = this.sirina * this.visina;
        byte[] R = new byte[pixli];
        byte[] G = new byte[pixli];
        byte[] B = new byte[pixli];

        short[] sekvenca = new short[64];
        short[] tmpBlok = new short[64];
        byte[] blok = new byte[64];

        short tmpSirina = this.sirina;

        short WN = (short)(this.sirina - 1);
        short HN = (short)(this.visina - 1);

        for (short i = 0; i < HN; i += 8)
        {
            for (short j = 0; j < WN; j += 8)
            {
                this.DobiSekvenco(sekvenca, ref trenutniIndex, this.mojiPodatki);
                this.DobiBlok(sekvenca, tmpBlok);
                this.ZazeniIDCT(tmpBlok, blok);
                this.PozicijaBloka(j, i, R, tmpSirina, blok);
            }
        }

        for (short i = 0; i < HN; i += 8)
        {
            for (short j = 0; j < WN; j += 8)
            {
                this.DobiSekvenco(sekvenca, ref trenutniIndex, this.mojiPodatki);
                this.DobiBlok(sekvenca, tmpBlok);
                this.ZazeniIDCT(tmpBlok, blok);
                this.PozicijaBloka(j, i, G, tmpSirina, blok);
            }
        }

        for (short i = 0; i < HN; i += 8)
        {
            for (short j = 0; j < WN; j += 8)
            {
                this.DobiSekvenco(sekvenca, ref trenutniIndex, this.mojiPodatki);
                this.DobiBlok(sekvenca, tmpBlok);
                this.ZazeniIDCT(tmpBlok, blok);
                this.PozicijaBloka(j, i, B, tmpSirina, blok);
            }
        }

        byte[] podatkiPixlov = new byte[pixli * 3];
        int stevec = 0;
        kompresija = new WriteableBitmap(this.sirina, this.visina);

        for (int i = 0; i < this.visina; i++)
        {
            for (int j = 0; j < this.sirina; j++)
            {
                this.kompresija.SetPixel(j, i, Color.FromArgb((byte)255, R[stevec], G[stevec], B[stevec]));
                stevec++;
            }
        }
    }

    #endregion

    public static void InitClass()
    {
        cos = new double[64, 64];
        const double PI = 3.141592653558979323;

        for (int u = 0; u < N; u++)
        {
            for (int v = 0; v < N; v++)
            {
                for (int i = 0; i < N; i++)
                {
                    for (int j = 0; j < N; j++)
                        cos[u * N + v, i * N + j] = Math.Cos(((2 * i + 1) * u * PI) / 16) * Math.Cos(((2 * (j) + 1) * v * PI) / 16);
                }
            }
        }
        vrednost = 1 / Math.Sqrt((double)2);
    }

}