﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using System.Windows.Media.Imaging;
using Microsoft.Phone;
using System.Collections.ObjectModel;
using Microsoft.Xna.Framework.Media;
using System.Text;
using Microsoft.Win32;
using System.IO;
using System.Windows.Interop;
using System.IO.IsolatedStorage;

namespace SlXnaApp1
{
    public partial class NaloziMapo_Navodila : PhoneApplicationPage
    {
        public NaloziMapo_Navodila()
        {
            InitializeComponent();

            brush = new ImageBrush();
            brush.ImageSource = new BitmapImage(new Uri("Navodila/navodila01.jpg", UriKind.Relative));
            LayoutRoot.Background = brush;
            prviPremik = true;
        }

        ImageBrush brush;
        Point pritisk;
        bool prviPremik = true;
        bool spremembaSmer = false;
        int index = -1;

        private void LayoutRoot_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            pritisk = new Point(e.GetPosition(null).X, e.GetPosition(null).Y);
        }
        
        private void LayoutRoot_MouseLeftButtonUp(object sender, MouseButtonEventArgs e)
        {
            double razlikaX = pritisk.X - e.GetPosition(null).X;
            double razlikaY = pritisk.Y - e.GetPosition(null).Y;
            
            if (prviPremik)
            {
                prviPremik = false;

                if ((razlikaY > 100) && (razlikaY > razlikaX))
                    spremembaSmer = true;
                else if ((razlikaY < -100) && (razlikaY < razlikaX))
                    spremembaSmer = false;
            }

            if (!spremembaSmer)
            {
                if ((razlikaY > 100) && (razlikaY > razlikaX))
                {
                    DesniPomik();
                    OsveziSliko();
                }
                else if ((razlikaY < -100) && (razlikaY < razlikaX))
                {
                    LeviPomik();
                    OsveziSliko();
                }
            }
            else
            {
                if ((razlikaY > 100) && (razlikaY > razlikaX))
                {
                    LeviPomik();
                    OsveziSliko();
                }
                else if ((razlikaY < -100) && (razlikaY < razlikaX))
                {
                    DesniPomik();
                    OsveziSliko();
                }
            }
        }

        private void OsveziSliko()
        {
            LayoutRoot.Background = (App.Current as App).zbirkaNavodila[index];
        }

        private void DesniPomik()
        {
            if (index > 0)
                index--;
        }

        private void LeviPomik()
        {
            if (index < (App.Current as App).zbirkaNavodila.Count - 1)
                index++;
        }


        // Počistimo sklad -> Strani, ki so za ciklane, če klikamo back, kako bomo skakali
        protected override void OnNavigatedTo(System.Windows.Navigation.NavigationEventArgs e)
        {
            while (this.NavigationService.BackStack.Any())
            {
                this.NavigationService.RemoveBackEntry();
            }
        }

        // Določimo, kam skočimo, ko kliknemo back
        protected override void OnBackKeyPress(System.ComponentModel.CancelEventArgs e)
        {
            NavigationService.Navigate(new Uri("/NaloziMapo.xaml", UriKind.RelativeOrAbsolute));
        }
    }
}