﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using System.Windows.Resources;
using System.Windows.Media.Imaging;
using Microsoft.Phone;
using System.Collections.ObjectModel;
using Microsoft.Xna.Framework.Media;
using System.Text;
using Microsoft.Win32;
using System.IO;
using System.Windows.Interop;
using System.IO.IsolatedStorage;

namespace SlXnaApp1
{
    public partial class NaloziMapo_PoglejSliko : PhoneApplicationPage
    {
        PictureAlbum cameraRoll = null;
        MediaLibrary ml = null;

        public NaloziMapo_PoglejSliko()
        {
            InitializeComponent();

            foreach (MediaSource source in MediaSource.GetAvailableMediaSources())
            {
                if (source.MediaSourceType == MediaSourceType.LocalDevice)
                {
                    ml = new MediaLibrary(source);
                    PictureAlbumCollection allAlbums = ml.RootPictureAlbum.Albums;

                    foreach (PictureAlbum album in allAlbums)
                    {
                        if (album.Name == "Camera Roll")
                        {
                            cameraRoll = album;
                        }
                    }
                }
            }

            if ((cameraRoll != null) && (cameraRoll.Pictures.Count > 0))
            {
                BitmapImage b = new BitmapImage();
                Picture p = cameraRoll.Pictures[cameraRoll.Pictures.Count - 1];
                b.SetSource(p.GetImage());

                int width = 650;
                int height = 480;
                WriteableBitmap writeableBitmap = new WriteableBitmap(b);
                WriteableBitmap writeableBmp = writeableBitmap.Resize(width, height, WriteableBitmapExtensions.Interpolation.Bilinear);

                MemoryStream stream = new MemoryStream();
                writeableBmp.SaveJpeg(stream, 650, 480, 0, 100);

                BitmapImage c = new BitmapImage();
                c.SetSource(stream);

                prikazSlike.Source = c;
                txtIzpisPoglejSliko.Text = "Želite zapreti?\nUporabite tipko za nazaj.";
            }
            else
                txtIzpisPoglejSliko.Text = "Galerija je prazna.\nZajemite novo sliko.";
        }

        // Počistimo sklad -> Strani, ki so za ciklane, če klikamo back, kako bomo skakali
        protected override void OnNavigatedTo(System.Windows.Navigation.NavigationEventArgs e)
        {
            while (this.NavigationService.BackStack.Any())
            {
                this.NavigationService.RemoveBackEntry();
            }
        }

        // Določimo, kam skočimo, ko kliknemo back
        protected override void OnBackKeyPress(System.ComponentModel.CancelEventArgs e)
        {
            NavigationService.Navigate(new Uri("/NaloziMapo.xaml", UriKind.RelativeOrAbsolute));
        }

        private void btnZapri_Click(object sender, RoutedEventArgs e)
        {
            NavigationService.Navigate(new Uri("/NaloziMapo.xaml", UriKind.RelativeOrAbsolute));
        }
    }
}