﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using Microsoft.Devices;
using Microsoft.Xna.Framework.Media;
using System.IO; 
using System.IO.IsolatedStorage; 
using Microsoft.Phone; 
using System.Windows.Resources; 
using System.Windows.Media.Imaging; 

namespace SlXnaApp1
{
    public partial class NaloziMapo_ZajemiSliko : PhoneApplicationPage
    {
        PhotoCamera cam;
        MediaLibrary library;

        public NaloziMapo_ZajemiSliko()
        {
            InitializeComponent();
            library = new MediaLibrary();
        }

        protected override void OnNavigatedTo(System.Windows.Navigation.NavigationEventArgs e)
        {
            if (PhotoCamera.IsCameraTypeSupported(CameraType.Primary) == true)
            {
                cam = new PhotoCamera(CameraType.Primary);
                cam.CaptureImageAvailable += new EventHandler<Microsoft.Devices.ContentReadyEventArgs>(cam_CaptureImageAvailable);
                viewfinderBrush.SetSource(cam);
            }
            else
                txtIzpisZajem.Text = "Fotoaparat na vašem telefonu ni na voljo.";
        }

        protected override void OnNavigatedFrom(System.Windows.Navigation.NavigationEventArgs e)
        {
            if (cam != null)
            {
                cam.Dispose();
            }
        }

        void viewfinder_Tapped(object sender, GestureEventArgs e)
        {
            if (cam != null)
            {
                try
                {
                    cam.CaptureImage();
                }
                catch (Exception ex)
                {
                    this.Dispatcher.BeginInvoke(delegate()
                    {
                        txtIzpisZajem.Text = ex.Message;
                    });
                }
            }
        }

        void cam_CaptureImageAvailable(object sender, Microsoft.Devices.ContentReadyEventArgs e)
        {
            string fileName = "hillWars.jpg";
            Deployment.Current.Dispatcher.BeginInvoke(delegate()
            {
                txtIzpisZajem.Text = "Slika je zajeta, poteka shranjevanje..";
            });

            library.SavePictureToCameraRoll(fileName, e.ImageStream);
            
            Deployment.Current.Dispatcher.BeginInvoke(delegate()
            {
                txtIzpisZajem.Text = "Slika je shranjena, lahko zajamete novo\n ali končate z pomikom nazaj.";
            });
        }

        protected override void OnOrientationChanged(OrientationChangedEventArgs e)
        {
            if (cam != null)
            {
                Dispatcher.BeginInvoke(() =>
                {
                    double rotation = cam.Orientation;

                    switch(this.Orientation)
                    {
                        case PageOrientation.LandscapeLeft:
                            rotation = cam.Orientation - 90;
                            break;
                        case PageOrientation.LandscapeRight:
                            rotation = cam.Orientation + 90;
                            break;
                    }
                    viewfinderTransform.Rotation = rotation;
                });
            }

            base.OnOrientationChanged(e);
        }

        // Določimo, kam skočimo, ko kliknemo back
        protected override void OnBackKeyPress(System.ComponentModel.CancelEventArgs e)
        {
            NavigationService.Navigate(new Uri("/NaloziMapo.xaml", UriKind.RelativeOrAbsolute));
        }
    }
}