﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;

namespace SlXnaApp1
{
    public partial class Nastavitve_Mapa : PhoneApplicationPage
    {
        public Nastavitve_Mapa()
        {
            InitializeComponent();

            txtRazpoznava.Visibility = System.Windows.Visibility.Collapsed;
            InicializacijaMapa();
        }
        
        private void InicializacijaMapa()
        {
            if ((App.Current as App).trenutnaMapa == 0)
            {
                rbtnPrivzeta.IsChecked = true;
                rbtnNakljucno.IsEnabled = false;
                rbtnZajemSlike.IsEnabled = false;
            }
            else if ((App.Current as App).trenutnaMapa == 1)
            {
                rbtnGenerirana.IsChecked = true;
                rbtnNakljucno.IsChecked = true;
                rbtnNakljucno.IsEnabled = true;
                rbtnZajemSlike.IsEnabled = true;
            }
            else if ((App.Current as App).trenutnaMapa == 2)
            {
                rbtnGenerirana.IsChecked = true;
                rbtnZajemSlike.IsChecked = true;
                rbtnNakljucno.IsEnabled = true;
                rbtnZajemSlike.IsEnabled = true;
            }

            txtPrivzetaRazlaga.Text = "Točke, razdelitev polj in število igralcev je\ndoločeno že v naprej (omejene nastavitve).";
            txtGeneriranaRazlaga.Text = "Izbira v naslednjem koraku vpliva na to,\nkako se bo ustvarila mapa, vendar pri\nzajemu slike je potrebno potrditi sliko.";
            txtGeneriranaNakljucneRazlaga.Text = "Naključna dodelitev točk in polj.\nMožnost spremembe nastavitev.";
            txtGeneriranaZajemRazlaga.Text = "Lahko zajamete sliko ali imate\nže razpoznano in tako ste določili ozemlja,\n možnost sprememb nastavitev.";
        }

        private void rbtnGenerirana_Checked(object sender, RoutedEventArgs e)
        {
            rbtnNakljucno.IsEnabled = true;
            rbtnZajemSlike.IsEnabled = true;
        }

        private void rbtnPrivzeta_Checked(object sender, RoutedEventArgs e)
        {
            rbtnNakljucno.IsEnabled = false;
            rbtnZajemSlike.IsEnabled = false;
            rbtnNakljucno.IsChecked = false;
            rbtnZajemSlike.IsChecked = false;
            (App.Current as App).trenutnaMapa = 0;
            txtRazpoznava.Visibility = System.Windows.Visibility.Collapsed;
        }

        private void rbtnNakljucno_Checked(object sender, RoutedEventArgs e)
        {
            (App.Current as App).trenutnaMapa = 1;
            txtRazpoznava.Visibility = System.Windows.Visibility.Collapsed;
        }

        private void rbtnZajemSlike_Checked(object sender, RoutedEventArgs e)
        {
            (App.Current as App).trenutnaMapa = 2;
            if ((App.Current as App).zajetaSlika)
                txtRazpoznava.Visibility = System.Windows.Visibility.Visible;

        }

        // Počistimo sklad -> Strani, ki so za ciklane, če klikamo back, kako bomo skakali
        protected override void OnNavigatedTo(System.Windows.Navigation.NavigationEventArgs e)
        {
            while (this.NavigationService.BackStack.Any())
            {
                this.NavigationService.RemoveBackEntry();
            }
        }

        // Določimo, kam skočimo, ko kliknemo back
        protected override void OnBackKeyPress(System.ComponentModel.CancelEventArgs e)
        {
            (App.Current as App).spremembe = true;
            if ((bool)rbtnPrivzeta.IsChecked)
            {
                (App.Current as App).nasaIgra = new WindowsGame1.Igra(1);
            }
            else if ((bool)rbtnNakljucno.IsChecked)
            {
                Random a = new Random();
                List<Microsoft.Xna.Framework.Color> barve = new List<Microsoft.Xna.Framework.Color>();
                for (int i = 0; i < (App.Current as App).playeri.Count; i++)
                {
                    barve.Add(Microsoft.Xna.Framework.Color.RoyalBlue);
                }

                (App.Current as App).nasaIgra = new WindowsGame1.Igra((App.Current as App).playeri.Count, (a.Next() % 20) + 4, barve);
            }
            else if ((bool)rbtnGenerirana.IsChecked)
            {
                if ((App.Current as App).zajetaSlika)
                {
                    NaloziMapo_PotrdiSliko nova = new NaloziMapo_PotrdiSliko();
                    nova.Razpoznava();
                }
                //(App.Current as App).nasaIgra = new WindowsGame1.Igra(1);
            }
            NavigationService.Navigate(new Uri("/MainPage.xaml", UriKind.RelativeOrAbsolute));
        }

        private void btnZapri_Click(object sender, RoutedEventArgs e)
        {
            (App.Current as App).spremembe = true;
            if ((bool)rbtnPrivzeta.IsChecked)
            {
                (App.Current as App).nasaIgra = new WindowsGame1.Igra(1);
            }
            else if ((bool)rbtnNakljucno.IsChecked)
            {
                Random a = new Random();
                List<Microsoft.Xna.Framework.Color> barve = new List<Microsoft.Xna.Framework.Color>();
                for (int i = 0; i < (App.Current as App).playeri.Count; i++)
			    {
                    barve.Add(Microsoft.Xna.Framework.Color.RoyalBlue);
			    }

                (App.Current as App).nasaIgra = new WindowsGame1.Igra((App.Current as App).playeri.Count, (a.Next()%20)+4, barve);
            }
            else if ((bool)rbtnGenerirana.IsChecked)
            {
                if ((App.Current as App).zajetaSlika)
                {
                    NaloziMapo_PotrdiSliko nova = new NaloziMapo_PotrdiSliko();
                    nova.Razpoznava();
                }
                //(App.Current as App).nasaIgra = new WindowsGame1.Igra(1);
            }
            NavigationService.Navigate(new Uri("/MainPage.xaml", UriKind.RelativeOrAbsolute));
        }
    }
}