﻿using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;
using SlXnaApp1;

namespace WindowsGame1
{
    public class Mapa
    {
        public string ime;
        public List<Polje> polja;
        public List<Skupina> skupine;

        public Mapa() { }

        public void dodeliRobneTočke()
        {
            
            List<System.Windows.Point> seznam = new List<System.Windows.Point>();

            foreach (Polje item in polja)
	        {
                seznam.Add(new System.Windows.Point(item.sredina.X, item.sredina.Y));
	        }
            SlXnaApp1.Razredi.Voronoj a = new SlXnaApp1.Razredi.Voronoj();
            List<List<System.Windows.Point>> b = a.TvoriVoronoievDiagram(seznam);
            //a.seznamTrikotnikov;

            for (int i = 0; i < b.Count; i++)
            {
                for (int j = 1; j < b[i].Count; j++)
                {
                    polja[i].robneTocke.Add(new Microsoft.Xna.Framework.Point((int)b[i][j].X, (int)b[i][j].Y));
                }
                //polja[i].robneTocke.Add(new Microsoft.Xna.Framework.Point((int)b[i][b[i].Count - 1].X, (int)b[i][b[i].Count - 1].Y));
            }

        }

        public double distance(Point a, Point b)
        {
            double D = Math.Pow((double)b.X - a.X, 2) + Math.Pow((double)b.Y - a.Y, 2);
            return Math.Abs(D);
        }

        public Mapa(string ime, List<Polje> polja, List<Skupina> skupine)
        {
            this.ime = ime;
            this.polja = new List<Polje>(polja);
            this.skupine = new List<Skupina>(skupine);

            //this.dodeliRobneTočke();
        }

        public Mapa(string ime, List<Polje> polja, List<Skupina> skupine, int dummy)
        {
            this.ime = ime;
            this.polja = new List<Polje>(polja);
            this.skupine = new List<Skupina>(skupine);

            this.dodeliRobneTočke();
        }

        //public Mapa(string ime, List<List<System.Windows.Point>> mnogokotniki, List<Voronoi> trikotniki, 

        public Mapa(Mapa trenutnaMapa)
        {
            ime = trenutnaMapa.ime;
            polja = new List<Polje>();
            for (int i = 0; i < trenutnaMapa.polja.Count; i++)
                polja.Add(new Polje(trenutnaMapa.polja[i].robneTocke, trenutnaMapa.polja[i].sredina, trenutnaMapa.polja[i].indexSoseda, trenutnaMapa.polja[i].skupina, trenutnaMapa.polja[i].indexLastnika, trenutnaMapa.polja[i].steviloVojakov));
            skupine = new List<Skupina>();
            for (int i = 0; i < trenutnaMapa.skupine.Count; i++)
                skupine.Add(new Skupina(trenutnaMapa.skupine[i].indexClana, trenutnaMapa.skupine[i].proizvodnja));
        }/**/

        public bool preveriPolja(int steviloIgralcev)
        {
            foreach (Polje trenutniElement in this.polja)
            {
                trenutniElement.preveriPolje(steviloIgralcev, this.polja.Count, this.skupine.Count);
            }
            foreach (Skupina trenutniElement in this.skupine)
            {
                trenutniElement.preveriSkupino(this.polja.Count);
            }
            return true;
        }
        
        /// <summary>
        /// Stvar dela :O TODO: Bregar
        /// </summary>
        /// <param name="indexIzvor"></param>
        /// <param name="indexDestinacija"></param>
        /// <returns></returns>
        public bool aliStaPoljiPovezani(int indexIzvor, int indexDestinacija)
        {
            int lastnik = this.polja[indexIzvor].indexLastnika;
            List<int> dostopni = new List<int>();
            dostopni.Add(indexIzvor);

            foreach (int st in this.polja[indexIzvor].indexSoseda)
            {
                if (this.polja[st].indexLastnika == lastnik)
                {
                    dostopni.Add(st);
                }
            }
            if (dostopni.Contains(indexDestinacija)) { return true; }
            else { return false; }
        }
    }
}
