﻿using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;

namespace WindowsGame1
{
    public class Polje
    {
        public List<Point> robneTocke;  //minimalno morajo biti 3
        public Point sredina;           //mora biti znotraj zgornjih točk
        public List<int> indexSoseda;   //minimalno eden
        public int skupina;
        public int indexLastnika;
        public int steviloVojakov;

        public Polje() { }

        public Polje(List<Point> robneTocke, Point sredina, List<int> indexSoseda, int skupina, int indexLastnika, int steviloVojakov)
        {
            this.robneTocke = new List<Point>(robneTocke);
            this.sredina = sredina;
            this.indexSoseda = new List<int>(indexSoseda);
            this.skupina = skupina;
            this.indexLastnika = indexLastnika;
            this.steviloVojakov = steviloVojakov;
        }

        public Polje(Point sredina, List<int> indexSoseda, int skupina, int indexLastnika, int steviloVojakov)
        {
            this.robneTocke = new List<Point>();//se bodo po novem same dodelile
            this.sredina = sredina;
            this.indexSoseda = new List<int>(indexSoseda);
            this.skupina = skupina;
            this.indexLastnika = indexLastnika;
            this.steviloVojakov = steviloVojakov;
        }

        public bool preveriPolje(int steviloIgralcev, int steviloPolj, int steviloSkupin)
        {
            if (this.indexSoseda.Count <= 1) { throw new Exception("Eno polje je popolnoma izolirano"); }
            foreach (int sosed in this.indexSoseda)
            {
                if (sosed < 0) { throw new Exception("Polje ima neveljavnega soseda, njegov index je negativen"); }
                if (sosed > steviloPolj) { throw new Exception("Polje ima soseda ki sploh ne obstaja"); }
            }

            if (skupina < 0 || skupina > steviloSkupin) { throw new Exception("Polje ima skupino, ki ne obstaja"); }
            if (this.indexLastnika < 0 || this.indexLastnika > steviloIgralcev) { throw new Exception("Polje ima lastnika, ki ne obstaja"); }

            //if (this.robneTocke.Count <= 2) { throw new Exception("Polje ima premalo robnih točk da bi lahko obstajalo"); }

            return true;
        }

        public bool jeSosed(int sosed)
        {
            foreach (int trenutniElement in this.indexSoseda)
            {
                if (trenutniElement == sosed) { return true; }
            }
            return false;
        }
    }
}
