﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using System.Windows.Resources;
using System.Windows.Media.Imaging;
using Microsoft.Phone;
using System.Collections.ObjectModel;
using Microsoft.Xna.Framework.Media;
using System.Text;
using Microsoft.Win32;
using System.IO;
using System.Windows.Interop;
using System.IO.IsolatedStorage;
using WindowsGame1;
using Microsoft.Phone.Tasks;

namespace SlXnaApp1.Razredi
{
    public class Voronoj
    {
        List<Point> seznamSredisc;
        List<List<Point>> seznamMnogokotnikov;
        public List<Voronoi> seznamTrikotnikov;

        #region Tvorjenje mape iz seznama središč

        public List<List<Point>> TvoriVoronoievDiagram(List<Point> seznamTock)
        {
            seznamSredisc = new List<Point>();
            foreach (Point item in seznamTock)
            {
                seznamSredisc.Add(new Point(item.X, item.Y));
            }

            List<WindowsGame1.delanoj.Geometry.Triangle> trikotniki;
            List<WindowsGame1.delanoj.Geometry.Point> delanojTocke = new List<WindowsGame1.delanoj.Geometry.Point>();

            #region Pretvorba v delanojeve točke
            foreach (Point tocka in seznamTock)
            {
                delanojTocke.Add(new WindowsGame1.delanoj.Geometry.Point(tocka.X, tocka.Y));
            }

            trikotniki = new List<WindowsGame1.delanoj.Geometry.Triangle>();
            trikotniki = WindowsGame1.delanoj.Delauney.Triangulate(delanojTocke);

            #endregion

            #region Izračun težišč in obdelava trikotnikov
            seznamTrikotnikov = new List<Voronoi>();
            Point tezisce = new Point();
            Point t1;
            Point t2;
            Point t3;

            foreach (WindowsGame1.delanoj.Geometry.Triangle trikotnik in trikotniki)
            {
                tezisce.X = (seznamSredisc[trikotnik.p1].X + seznamSredisc[trikotnik.p2].X + seznamSredisc[trikotnik.p3].X) / 3;
                tezisce.Y = (seznamSredisc[trikotnik.p1].Y + seznamSredisc[trikotnik.p2].Y + seznamSredisc[trikotnik.p3].Y) / 3;

                t1 = new Point(seznamSredisc[trikotnik.p1].X, seznamSredisc[trikotnik.p1].Y);
                t2 = new Point(seznamSredisc[trikotnik.p2].X, seznamSredisc[trikotnik.p2].Y);
                t3 = new Point(seznamSredisc[trikotnik.p3].X, seznamSredisc[trikotnik.p3].Y);
                seznamTrikotnikov.Add(new Voronoi(t1, t2, t3, tezisce));
            }
            #endregion

            #region Odstranjevanje trikotnikov
            double r12 = 0, r23 = 0, r13 = 0;

            for (int i = 0; i < seznamTrikotnikov.Count; i++)
            {
                if (seznamTrikotnikov[i].indexiSosedov.Count < 3)
                {
                    r12 = Math.Sqrt(Razdalja(seznamTrikotnikov[i].Tocka1, seznamTrikotnikov[i].Tocka2));
                    r23 = Math.Sqrt(Razdalja(seznamTrikotnikov[i].Tocka2, seznamTrikotnikov[i].Tocka3));
                    r13 = Math.Sqrt(Razdalja(seznamTrikotnikov[i].Tocka1, seznamTrikotnikov[i].Tocka3));
                    if (Math.Acos((r12 * r12 + r13 * r13 - r23 * r23) / (2 * r12 * r13)) * 180 / Math.PI < 20 && Math.Acos((r12 * r12 + r23 * r23 - r13 * r13) / (2 * r12 * r23)) * 180 / Math.PI < 20 ||
                        Math.Acos((r12 * r12 + r23 * r23 - r13 * r13) / (2 * r12 * r23)) * 180 / Math.PI < 20 && Math.Acos((r13 * r13 + r23 * r23 - r12 * r12) / (2 * r13 * r23)) * 180 / Math.PI < 20 ||
                        Math.Acos((r13 * r13 + r23 * r23 - r12 * r12) / (2 * r13 * r23)) * 180 / Math.PI < 20 && Math.Acos((r12 * r12 + r13 * r13 - r23 * r23) / (2 * r12 * r13)) * 180 / Math.PI < 20)
                    {
                        seznamTrikotnikov.RemoveAt(i);
                    }
                }
            }
            #endregion

            #region Obdelava trikotnikov
            int stevecRobov = 0;
            bool tocka1 = false;
            bool tocka2 = false;
            bool tocka3 = false;
            bool rob12 = false;
            bool rob13 = false;
            bool rob23 = false;

            for (int i = 0; i < seznamTrikotnikov.Count; i++)
            {
                rob12 = false;
                rob13 = false;
                rob23 = false;

                for (int j = 0; j < seznamTrikotnikov.Count; j++)
                {
                    if (i != j)
                    {
                        tocka1 = false;
                        tocka2 = false;
                        tocka3 = false;
                        stevecRobov = 0;

                        // Točka 1
                        if ((seznamTrikotnikov[i].Tocka1 == seznamTrikotnikov[j].Tocka1) || (seznamTrikotnikov[i].Tocka1 == seznamTrikotnikov[j].Tocka2) || (seznamTrikotnikov[i].Tocka1 == seznamTrikotnikov[j].Tocka3))
                        {
                            stevecRobov++;
                            tocka1 = true;
                        }

                        // Točka 2
                        if ((seznamTrikotnikov[i].Tocka2 == seznamTrikotnikov[j].Tocka1) || (seznamTrikotnikov[i].Tocka2 == seznamTrikotnikov[j].Tocka2) || (seznamTrikotnikov[i].Tocka2 == seznamTrikotnikov[j].Tocka3))
                        {
                            stevecRobov++;
                            tocka2 = true;
                        }

                        // Točka 3
                        if ((seznamTrikotnikov[i].Tocka3 == seznamTrikotnikov[j].Tocka1) || (seznamTrikotnikov[i].Tocka3 == seznamTrikotnikov[j].Tocka2) || (seznamTrikotnikov[i].Tocka3 == seznamTrikotnikov[j].Tocka3))
                        {
                            stevecRobov++;
                            tocka3 = true;
                        }

                        if (stevecRobov >= 2)
                            seznamTrikotnikov[i].indexiSosedov.Add(j);

                        if (tocka1 && tocka2)
                            rob12 = true;
                        if (tocka1 && tocka3)
                            rob13 = true;
                        if (tocka2 && tocka3)
                            rob23 = true;
                    }
                }

                if (!rob12)
                    seznamTrikotnikov[i].DodajRob(seznamTrikotnikov[i].Tocka1, seznamTrikotnikov[i].Tocka2);
                if (!rob13)
                    seznamTrikotnikov[i].DodajRob(seznamTrikotnikov[i].Tocka1, seznamTrikotnikov[i].Tocka3);
                if (!rob23)
                    seznamTrikotnikov[i].DodajRob(seznamTrikotnikov[i].Tocka2, seznamTrikotnikov[i].Tocka3);
            }
            #endregion

            #region Tvorjenje točk na bounding box-u :)
            Point polovicka;
            double koef = 0;
            double zac = 0;
            double razX = 0;
            double razY = 0;
            double novX = 0;
            double novY = 0;
            foreach (Voronoi trikotnik in seznamTrikotnikov)
            {
                if (trikotnik.indexiSosedov.Count < 3)
                {
                    foreach (Voronoi.Rob rob in trikotnik.robovi)
                    {
                        polovicka = new Point((rob.T1.X + rob.T2.X) / 2, (rob.T1.Y + rob.T2.Y) / 2);
                        razY = polovicka.Y - trikotnik.Tezisce.Y;
                        razX = polovicka.X - trikotnik.Tezisce.X;
                        if (razX == 0) { razX = 1; }
                        koef = razY / razX;
                        zac = polovicka.Y - (koef * polovicka.X);
                        if (koef == 0)
                        {
                            novY = trikotnik.Tezisce.Y;
                            if (razX > 0) { novX = 650; }
                            else { novX = 0; }
                        }
                        if (koef > 0)
                        {
                            if (razX > 0)//desno|dol
                            {
                                if (koef * 650 + zac >= 480)
                                {
                                    novY = 480;
                                    novX = (novY - zac) / koef;
                                }
                                else
                                {
                                    novX = 650;
                                    novY = koef * novX + zac;
                                }
                            }
                            else//levo|gor
                            {
                                if (zac < 0)
                                {
                                    novY = 0;
                                    novX = (novY - zac) / koef;
                                }
                                else
                                {
                                    novY = zac;
                                    novX = 0;
                                }
                            }
                        }
                        if (koef < 0)
                        {
                            if (razX > 0)//desno|gor
                            {
                                if ((0 - zac) / koef >= 650)
                                {
                                    novX = 650;
                                    novY = koef * novX + zac;
                                }
                                else
                                {
                                    novY = 0;
                                    novX = (novY - zac) / koef;
                                }
                            }
                            else//levo|dol
                            {
                                if (zac >= 480)
                                {
                                    novY = 480;
                                    novX = (novY - zac) / koef;
                                }
                                else
                                {
                                    novX = 0;
                                    novY = zac;
                                }
                            }
                        }
                        //trikotnik.tockeBB.Add(new Point((int)novX, (int)novY));
                        trikotnik.tockeBB.Add(new Voronoi.tockaBB(rob.T1, rob.T2, new Point((int)novX, (int)novY)));
                    }

                }
            }
            #endregion

            #region Mnogokotnike dodelimo središčem in dodamo ustrezne kotne točke
            List<List<Point>> seznamM = new List<List<Point>>();
            List<Point> mnogokotnik;
            List<Voronoi.tockaBB> tmpZbirka = new List<Voronoi.tockaBB>();
            foreach (Point sredisce in seznamSredisc)
            {
                mnogokotnik = new List<Point>();
                mnogokotnik.Add(sredisce);
                seznamM.Add(mnogokotnik);
            }

            foreach (Voronoi trikotnik in seznamTrikotnikov)
            {
                foreach (List<Point> sredisce in seznamM) // sredisce[0] -> prva točka v seznami je točka središča
                {
                    tmpZbirka.Clear();

                    if (sredisce[0] == trikotnik.Tocka1 || sredisce[0] == trikotnik.Tocka2 || sredisce[0] == trikotnik.Tocka3)
                        sredisce.Add(trikotnik.Tezisce); // dodajamo težišča

                    tmpZbirka = vrniTockoBB(sredisce[0]);

                    // dodamo BB točke, vsakemu središču
                    for (int i = 1; i < tmpZbirka.Count; i++)
                    {
                        sredisce.Add(tmpZbirka[i - 1].BBTocka);
                        sredisce.Add(tmpZbirka[i].BBTocka);

                        if (((tmpZbirka[i - 1].BBTocka.X == 0) && tmpZbirka[i].BBTocka.Y == 0) ||
                            ((tmpZbirka[i - 1].BBTocka.Y == 0) && tmpZbirka[i].BBTocka.X == 0))
                            sredisce.Add(new Point(0, 0));

                        if (((tmpZbirka[i - 1].BBTocka.X == 650) && tmpZbirka[i].BBTocka.Y == 0) ||
                            ((tmpZbirka[i - 1].BBTocka.Y == 0) && tmpZbirka[i].BBTocka.X == 650))
                            sredisce.Add(new Point(650, 0));

                        if (((tmpZbirka[i - 1].BBTocka.X == 650) && tmpZbirka[i].BBTocka.Y == 480) ||
                            ((tmpZbirka[i - 1].BBTocka.Y == 480) && tmpZbirka[i].BBTocka.X == 650))
                            sredisce.Add(new Point(650, 480));

                        if (((tmpZbirka[i - 1].BBTocka.X == 0) && tmpZbirka[i].BBTocka.Y == 480) ||
                            ((tmpZbirka[i - 1].BBTocka.Y == 480) && tmpZbirka[i].BBTocka.X == 0))
                            sredisce.Add(new Point(0, 480));

                        if (((tmpZbirka[i - 1].BBTocka.Y == 0) && tmpZbirka[i].BBTocka.Y == 480) ||
                            ((tmpZbirka[i - 1].BBTocka.Y == 480) && tmpZbirka[i].BBTocka.Y == 0))
                        {
                            if (sredisce[0].X >= 325) // več kot polovica
                            {
                                sredisce.Add(new Point(650, 0));
                                sredisce.Add(new Point(650, 480));
                            }
                            else
                            {
                                sredisce.Add(new Point(0, 0));
                                sredisce.Add(new Point(0, 480));
                            }
                        }

                        if (((tmpZbirka[i - 1].BBTocka.X == 0) && tmpZbirka[i].BBTocka.X == 650) ||
                            ((tmpZbirka[i - 1].BBTocka.X == 650) && tmpZbirka[i].BBTocka.X == 0))
                        {
                            if (sredisce[0].Y >= 240)
                            {
                                sredisce.Add(new Point(0, 480));
                                sredisce.Add(new Point(650, 480));
                            }
                            else
                            {
                                sredisce.Add(new Point(0, 0));
                                sredisce.Add(new Point(650, 0));
                            }
                        }
                    }
                }
            }

            // Urejanje točk
            List<Point> tempList;
            Point prv;
            for (int i = 0; i < seznamM.Count; i++)
            {
                tempList = seznamM[i];
                prv = tempList[0];
                tempList.RemoveAt(0);
                tempList = graham(tempList);
                seznamM[i].Clear();
                seznamM[i].Add(prv);
                foreach (Point tck in tempList)
                {
                    seznamM[i].Add(tck);
                }
            }
            #endregion

            #region Odstranjevanje mnogokotnikov
            Point dupe;
            foreach (List<Point> mnogokotnk in seznamM)
            {
                for (int i = 0; i < mnogokotnk.Count(); i++)
                {
                    dupe = mnogokotnk[i];
                    for (int j = i + 1; j < mnogokotnk.Count(); j++)
                    {
                        if (mnogokotnk[j] == dupe)
                        {
                            mnogokotnk.RemoveAt(j);
                            i = 0;
                        }
                    }
                }
            }
            #endregion

            return seznamM;
        }

        public List<Voronoi.tockaBB> vrniTockoBB(Point trenutnaTocka)
        {
            List<Voronoi.tockaBB> tockeBB = new List<Voronoi.tockaBB>();

            foreach (Voronoi trikotnik in seznamTrikotnikov)
            {
                foreach (Voronoi.tockaBB rob in trikotnik.tockeBB)
                {
                    if ((trenutnaTocka == rob.RobnaT1) || (trenutnaTocka == rob.RobnaT2))
                        tockeBB.Add(new Voronoi.tockaBB(rob.RobnaT1, rob.RobnaT2, rob.BBTocka));
                }
            }

            return tockeBB;
        }

        public double Razdalja(Point Tocka1, Point Tocka2)
        {
            double D = Math.Pow((double)Tocka2.X - Tocka1.X, 2) + Math.Pow((double)Tocka2.Y - Tocka1.Y, 2);
            return Math.Abs(D);
        }

        struct tocka
        {
            public double X;
            public double Y;
            public double kot;
        };

        public List<Point> graham(List<Point> seznamTock)
        {
            List<Point> Lupina = new List<Point>();
            List<tocka> seznamm = new List<tocka>();
            tocka temp = new tocka();
            tocka min = new tocka();
            Point luptmp = new Point();
            int i = 0;
            Point min2 = new Point();
            tocka minVec = new tocka();
            tocka currVec = new tocka();
            double vecProd = 0.00;
            Point prva, druga, tretja;

            min.kot = 0;
            min.X = seznamTock[0].X;
            min.Y = seznamTock[0].Y;

            foreach (Point toc in seznamTock)
            {
                temp.X = toc.X;
                temp.Y = toc.Y;
                temp.kot = 0;
                seznamm.Add(temp);

                if (temp.Y < min.Y)
                {
                    min = temp;
                }
                else
                {
                    if (temp.Y == min.Y && temp.X < min.X)
                    {
                        min = temp;
                    }
                }
            }
            //minimalna tocka v min
            luptmp.X = min.X;
            luptmp.Y = min.Y;
            min2.X = min.X + 100;
            min2.Y = min.Y;
            minVec.X = min2.X - min.X;
            minVec.Y = min2.Y - min.Y;

            for (i = 0; i < seznamm.Count; i++)
            {
                temp.X = seznamm[i].X;
                temp.Y = seznamm[i].Y;
                currVec.X = temp.X - min.X;
                currVec.Y = temp.Y - min.Y;
                temp.kot = (minVec.X * currVec.X + minVec.Y * currVec.Y) / ((Math.Sqrt(minVec.X * minVec.X + minVec.Y * minVec.Y)) * (Math.Sqrt(currVec.X * currVec.X + currVec.Y * currVec.Y)));
                temp.kot = Math.Acos(temp.kot) * (180.0 / Math.PI);
                seznamm[i] = temp;
            }
            //koti zracunani.

            seznamm.Sort((x, y) => x.kot.CompareTo(y.kot));

            luptmp.X = seznamm[0].X;
            luptmp.Y = seznamm[0].Y;
            Lupina.Add(luptmp);

            luptmp.X = seznamm[1].X;
            luptmp.Y = seznamm[1].Y;
            Lupina.Add(luptmp);

            for (i = 0; i < seznamm.Count; i++)
            {
                luptmp.X = seznamm[i].X;
                luptmp.Y = seznamm[i].Y;
                Lupina.Add(luptmp);
            }


            for (i = 2; i < Lupina.Count; i++)
            {
                prva = new Point();
                druga = new Point();
                tretja = new Point();

                prva.X = Lupina[i - 2].X;
                prva.Y = Lupina[i - 2].Y;
                druga.X = Lupina[i - 1].X;
                druga.Y = Lupina[i - 1].Y;
                tretja.X = Lupina[i].X;
                tretja.Y = Lupina[i].Y;

                minVec.X = druga.X - prva.X;
                minVec.Y = druga.Y - prva.Y;
                currVec.X = tretja.X - druga.X;
                currVec.Y = tretja.Y - druga.Y;

                vecProd = (minVec.X * currVec.Y) - (minVec.Y * currVec.X);
            }
            return Lupina;
        }

        #endregion
    }
}
