﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using System.Windows.Resources;
using System.Windows.Media.Imaging;
using Microsoft.Phone;
using System.Collections.ObjectModel;
using Microsoft.Xna.Framework.Media;
using System.Text;
using Microsoft.Win32;
using System.IO;
using System.Windows.Interop;
using System.IO.IsolatedStorage;
using System.ComponentModel;

namespace SlXnaApp1
{
    public partial class Rezultat : PhoneApplicationPage
    {
        public Rezultat()
        {
            InitializeComponent();

            izpis.Text = "";
            btnShrani.Visibility = System.Windows.Visibility.Collapsed;
            izpis.Visibility = System.Windows.Visibility.Collapsed;
            btnShrani.IsEnabled = false;
            /*
            BitmapImage a = new BitmapImage(new Uri("Slike/Nalagam.jpg"));
            prikaz.Source = a;
            */
            if ((App.Current as App).narejenDCT)
            {
                (App.Current as App).mojDCT = new DCT();
                WriteableBitmap writeableBmp = new WriteableBitmap((App.Current as App).mojDCT.kompresija);
                
                MemoryStream stream = new MemoryStream();
                writeableBmp.SaveJpeg(stream, 800, 480, 0, 100);

                BitmapImage c = new BitmapImage();
                c.SetSource(stream);

                prikaz.Source = c;

                if ((App.Current as App).zvok)
                    Zvok();

                btnShrani.Visibility = System.Windows.Visibility.Visible;
                btnShrani.IsEnabled = true;
            }
        }

        private void btnShrani_Click(object sender, RoutedEventArgs e)
        {
            var fileName = String.Format("hillWars_{0:}.jpg", DateTime.Now.Ticks);

            using (var stream = new System.IO.MemoryStream())
            {
                // Save the picture to the Windows Phone media library.
                (App.Current as App).mojDCT.kompresija.SaveJpeg(stream, 800, 480, 0, 100);
                stream.Seek(0, System.IO.SeekOrigin.Begin);
                new MediaLibrary().SavePicture(fileName, stream);
            }

            izpis.Visibility = System.Windows.Visibility.Visible;
            izpis.Text = "Slika je shranjena v galerijo\n -> album: \"Saved pictures\"";
        }

        // Počistimo sklad -> Strani, ki so za ciklane, če klikamo back, kako bomo skakali
        protected override void OnNavigatedTo(System.Windows.Navigation.NavigationEventArgs e)
        {
            if (!(App.Current as App).narejenDCT)
            {
                (App.Current as App).napaka = "Ni rezultata, saj niste odigrali še nobene\nigre medtem ko je zagnana aplikacija.";
                NavigationService.Navigate(new Uri("/Napaka.xaml", UriKind.Relative));
            }

            while (this.NavigationService.BackStack.Any())
            {
                this.NavigationService.RemoveBackEntry();
            }
        }

        // Določimo, kam skočimo, ko kliknemo back
        protected override void OnBackKeyPress(System.ComponentModel.CancelEventArgs e)
        {
            NavigationService.Navigate(new Uri("/MainPage.xaml", UriKind.RelativeOrAbsolute));
        }

        private void btnZapri_Click(object sender, RoutedEventArgs e)
        {
            NavigationService.Navigate(new Uri("/MainPage.xaml", UriKind.RelativeOrAbsolute));
        }

        private void Zvok()
        {
            fanfare.Play();
            fanfare.MediaEnded += MediaEnded;
        }

        private void MediaEnded(object sender, RoutedEventArgs e)
        {
            fanfare.Position = TimeSpan.FromSeconds(0);
            fanfare.Play();
        }
    }
}