﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace WindowsGame1.Umetna_inteligenca
{
    class UI
    {
        public Igra trenutnaIgra;
        private int igralecNaVrsti;

        public UI(Igra trenutnaIgra)
        {
            this.trenutnaIgra = new Igra(trenutnaIgra);
            this.igralecNaVrsti = this.trenutnaIgra.naPotezi;
        }

        #region - Okrepitve - Poiščemo največji odmik, oziroma najslabše naselje, kjer je povprečje okrog veliko -> upravlja funkcija, index ki ga nam vrne, odstranimo element iz zbirke, tam kjer dobimo vrnjen index
        public int vrniOzemlje(List<Okrepitve> zbirka)
        {
            double razlika = 0;
            double minRazlika = Int32.MaxValue;
            int index = -1;

            for (int i = 0; i < zbirka.Count; i++)
            {
                razlika = zbirka[i].steviloVojakov - zbirka[i].povprecjeVojakov;

                if (razlika < minRazlika)
                {
                    minRazlika = razlika;
                    index = i;
                }
            }

            return index;
        }
        #endregion

        #region - Napad - Računanje verjetnosti
        public List<Napadanje> izracunajVerjetnost()
        {
            List<Napadanje> zbirka = new List<Napadanje>();
            int index = -1;
            int indexSoseda = -1;
            double povprecje = 0;
            double povprecjeSoseda = 0;
            int numSosedov = 0;
            const int konstanta = 10;
            int faktor = trenutnaIgra.mapa.polja.Count;
            int razlikaEnot;
            double verjetnost = 0;
            Random rand;

            for (int i = 0; i < trenutnaIgra.igralci[igralecNaVrsti].indexPolj.Count; i++)
            {
                verjetnost = 0;
                index = trenutnaIgra.igralci[igralecNaVrsti].indexPolj[i];
                povprecje = trenutnaIgra.vrniPovprecjeEnot(index, igralecNaVrsti); // funkcija vrne povprečje, torej vojsko sosedov sešteje in deli s številom ozemlij
                numSosedov = trenutnaIgra.mapa.polja[index].indexSoseda.Count;
                verjetnost = verjetnost + ((konstanta * faktor) / povprecje);

                for (int j = 0; j < numSosedov; j++)
                {
                    indexSoseda = trenutnaIgra.mapa.polja[index].indexSoseda[j];
                    razlikaEnot = trenutnaIgra.mapa.polja[index].steviloVojakov - trenutnaIgra.mapa.polja[indexSoseda].steviloVojakov;
                    povprecjeSoseda = trenutnaIgra.vrniPovprecjeEnot(indexSoseda, trenutnaIgra.mapa.polja[indexSoseda].indexLastnika);

                    if (trenutnaIgra.mapa.polja[index].skupina == trenutnaIgra.mapa.polja[indexSoseda].skupina)
                        verjetnost = verjetnost + (konstanta * faktor);

                    verjetnost = verjetnost + (konstanta * razlikaEnot);
                    verjetnost = verjetnost + ((konstanta * faktor) / povprecjeSoseda);

                    //Console.WriteLine("IGRALEC: " + igralecNaVrsti + " -> index[N]: " + index + " | skupina[N]: " + trenutnaIgra.mapa.polja[index].skupina + " | index[B]: " + indexSoseda + " | skupina[B]: " + trenutnaIgra.mapa.polja[indexSoseda].skupina + " | verjetnost: " + verjetnost);
                    rand = new Random();
                    verjetnost = verjetnost * (rand.Next(1, 50) / 10);

                    zbirka.Add(new Napadanje(index, indexSoseda, verjetnost));
                }
            }

            return zbirka;
        }
        #endregion

        #region - Fortifikacija - Vrne int povprečje
        public int zaokrozitevPovprecja(double povprecje)
        {
            double tmp = povprecje % 1;
            if (tmp >= 0.5)
                return 1;
            return 0;
        }
        #endregion

        public void FazaIgre_Okrepitve()
        {
            trenutnaIgra.faza = fazaIgre.okrepitve; // obvezna sprememba faze igre -> okrepitve

            List<Okrepitve> zbirka = new List<Okrepitve>();

            #region Glede na vsako naselje trenutnega igralca, poračunamo povprečje vojakov okoli tega ozemlja
            int index = -1;
            double povprecje = 0;

            for (int i = 0; i < trenutnaIgra.igralci[igralecNaVrsti].indexPolj.Count; i++)
            {
                index = trenutnaIgra.igralci[igralecNaVrsti].indexPolj[i];
                povprecje = trenutnaIgra.vrniPovprecjeEnot(index, igralecNaVrsti); // funkcija vrne povprečje, torej vojsko sosedov sešteje in deli s številom ozemlij

                zbirka.Add(new Okrepitve(index, povprecje, trenutnaIgra.mapa.polja[index].steviloVojakov));
            }
            #endregion

            #region Na ozemlje, kjer je največji odmik, dodamo proizvodnjo, če je odmik majhen in imamo na voljo več vojakov, ostale dodamo drugam, na drugo najslabše
            bool konec = false;
            int proizvodnja = trenutnaIgra.igralci[igralecNaVrsti].proizvodnja;

            while (!konec)
            {
                index = vrniOzemlje(zbirka);

                // če je razlika večja od proizvodnja, pomeni, da ne rabimo vseh vojakov na tem ozemlju in lahko uvrstimo vojake še drugam
                if (proizvodnja > 0)
                {
                    if ((int)(zbirka[index].steviloVojakov - zbirka[index].povprecjeVojakov) >= 0)
                    {
                        trenutnaIgra.mapa.polja[zbirka[index].indexOzemlja].steviloVojakov++;
                        proizvodnja--;
                    }
                    else
                    {
                        trenutnaIgra.mapa.polja[zbirka[index].indexOzemlja].steviloVojakov += proizvodnja;
                        proizvodnja = 0;
                        konec = true;
                    }
                }
                else
                    konec = true;
            }
            #endregion

            zbirka.Clear();
        }

        //public List<Napadanje> FazaIgre_Napadanje()
        public void FazaIgre_Napadanje()
        {
            trenutnaIgra.faza = fazaIgre.napadanje; // obvezna sprememba faze igre -> napadanje

            List<Napadanje> zbirka = new List<Napadanje>();

            #region Napadanje
            
            zbirka = new List<Napadanje>(izracunajVerjetnost());

            double vsota = 0;
            double povprecnaVrednost = 0;

            for (int i = 0; i < zbirka.Count; i++)
                vsota = vsota + zbirka[i].verjetnostNapada;
            povprecnaVrednost = vsota / zbirka.Count;

           
            int index = -1;
            int indexSoseda = -1;
            
            int numElementi = zbirka.Count - 1;

            while (numElementi >= 0)
            {
                index = zbirka[numElementi].indexOzemlja;
                indexSoseda = zbirka[numElementi].indexSoseda;

                //Console.WriteLine("Napad iz: " + index + " | na: " + indexSoseda + " | verjetnost: " + zbirka[zbirka.Count - 1].verjetnostNapada);

                trenutnaIgra.napadi(index, indexSoseda);

                zbirka.RemoveAt(numElementi);
                numElementi--;
            }
            
            zbirka.Clear();
            
            #endregion

            //return zbirka;
        }

        public void FazaIgre_Fortifikacija()
        {
            trenutnaIgra.faza = fazaIgre.fortifikacija; // obvezna sprememba faze igre -> fortifikacija

            List<Fortifikacija> zbirka = new List<Fortifikacija>();

            #region poskrbimo, da bomo pregledali vsa naselja, ki jih ima igralec na vrsti
            int index = -1;
            int indexSosed = -1;
            double povprecje = 0;
            double povprecjeSosed = 0;
            int steviloEnot = 0;
            int steviloEnotSosed = 0;
            int x = 0;
            int tehnoloskiVisek = 0;
            double maxPovprecje = 1;
            int tmpIndex = -1;
            Random rand;
            bool konec = false;
            bool najdenMax = false;
            int sestej = 0;

            igralecNaVrsti = trenutnaIgra.naPotezi;

            for (int i = 0; i < trenutnaIgra.igralci[igralecNaVrsti].indexPolj.Count; i++)
            {
                index = trenutnaIgra.igralci[igralecNaVrsti].indexPolj[i];
                povprecje = trenutnaIgra.vrniPovprecjeEnot(index, igralecNaVrsti);
                steviloEnot = trenutnaIgra.mapa.polja[index].steviloVojakov;
                x = zaokrozitevPovprecja(povprecje);

                //Console.WriteLine("\nindex: " + index + " | avg: " + povprecje + " | avg(int): " + ((int)povprecje + x) + " | army: " + steviloEnot + " | diff: " + ((int)povprecje + x - steviloEnot));

                tehnoloskiVisek = 0;
                sestej = ((int)povprecje + x - steviloEnot);

                zbirka.Add(new Fortifikacija(index, povprecje, ((int)povprecje + x), sestej, true));

                if ((sestej < 0) && (trenutnaIgra.mapa.polja[index].steviloVojakov > 1))
                {
                    sestej = sestej * (-1);

                    if ((trenutnaIgra.mapa.polja[index].steviloVojakov - sestej) >= 1)
                    {
                        tehnoloskiVisek = tehnoloskiVisek + sestej;
                        trenutnaIgra.mapa.polja[index].steviloVojakov = trenutnaIgra.mapa.polja[index].steviloVojakov - sestej;
                    }
                    else
                    {
                        int tmpStanje = 0;

                        while ((tmpStanje >= 1) && (sestej >= 0))
                        {
                            trenutnaIgra.mapa.polja[index].steviloVojakov--;
                            tmpStanje = trenutnaIgra.mapa.polja[index].steviloVojakov;
                            sestej--;
                            tehnoloskiVisek++;
                        }
                    }

                    //Console.WriteLine("\t\t--> tehnoloski visek: " + tehnoloskiVisek + " | stevilo enot na ozemlju: " + trenutnaIgra.mapa.polja[index].steviloVojakov);
                }

                #region Podatki o sosedih
                for (int j = 0; j < trenutnaIgra.mapa.polja[index].indexSoseda.Count; j++)
                {
                    indexSosed = trenutnaIgra.mapa.polja[index].indexSoseda[j];
                    povprecjeSosed = trenutnaIgra.vrniPovprecjeEnot(indexSosed, igralecNaVrsti);
                    steviloEnotSosed = trenutnaIgra.mapa.polja[indexSosed].steviloVojakov;
                    x = zaokrozitevPovprecja(povprecjeSosed);

                    //Console.WriteLine("\n\tindex: " + indexSosed + " | avg: " + povprecjeSosed + " | avg(int): " + ((int)povprecjeSosed + x) + " | army: " + steviloEnotSosed + " | diff: " + ((int)povprecjeSosed + x - steviloEnotSosed));

                    // preverimo, ali imata index in sosed enakega lastnika
                    if (trenutnaIgra.jeEnakLastnik(index, indexSosed))
                    {
                        //Console.WriteLine("\t--> X: " + index + " & N: " + indexSosed + "\t+ Omogoceno premikanje!");

                        // DELITEV ENOT "FORTIFIKACIJA" - PREMIKANJE!
                        /*
                            ideja:
                            - preverjamo, kjer je minus in dodajamo v novo spremenljivko vrednosti, seveda ne smemo pozabiti zmanjševati na določenem ozemlju število vojakov
                            - potem gremo skozi in dodajamo enote dokler jih imamo več kot 0, na ozemlja, kjer je razlika > 0, prednosst ima večje povprečje
                                - če enote ostanejo, jih razdelimo glede na povprečje (razmisli: soseov)
                                - ali jih naključno namečemo nazaj nekam..
                        */

                        sestej = ((int)povprecje + x - steviloEnotSosed);
                        zbirka.Add(new Fortifikacija(indexSosed, povprecjeSosed, ((int)povprecjeSosed + x), ((int)povprecjeSosed + x - steviloEnotSosed), false));
                    
                        if ((sestej < 0) && (trenutnaIgra.mapa.polja[indexSosed].steviloVojakov > 1))
                        {
                            sestej = sestej * (-1);

                            if ((trenutnaIgra.mapa.polja[indexSosed].steviloVojakov - sestej) >= 1)
                            {
                                tehnoloskiVisek = tehnoloskiVisek + sestej;
                                trenutnaIgra.mapa.polja[indexSosed].steviloVojakov = trenutnaIgra.mapa.polja[indexSosed].steviloVojakov - sestej;
                            }
                            else
                            {
                                int tmpStanje = 0;

                                while ((tmpStanje >= 1) && (sestej >= 0))
                                {
                                    trenutnaIgra.mapa.polja[indexSosed].steviloVojakov--;
                                    tmpStanje = trenutnaIgra.mapa.polja[indexSosed].steviloVojakov;
                                    sestej--;
                                    tehnoloskiVisek++;
                                }
                            }

                            /*
                            if (trenutnaIgra.mapa.polja[indexSosed].steviloVojakov <= 0)
                                Console.WriteLine("0");
                            */
                              
                            //Console.WriteLine("\t\t--> PREMIK: DA | tehnoloski visek: " + tehnoloskiVisek + " | stevilo enot na ozemlju: " + trenutnaIgra.mapa.polja[indexSosed].steviloVojakov);
                        }
                        //else
                            //Console.WriteLine("\t\t--> PREMIK: NE | tehnoloski visek: " + tehnoloskiVisek + " | stevilo enot na ozemlju: " + trenutnaIgra.mapa.polja[indexSosed].steviloVojakov);
                    }
                    //else
                        //Console.WriteLine("\t--> X: " + index + " & N: " + indexSosed + "\t- Neomogoceno premikanje!");
                }
                #endregion

                #region Razporedimo tehnološki višek
                /*
                    razporedimo tehnološki višek vojakov
                    - prednost imajo naselja, ki so sosednja z velikim povprečjem (pomeni, da ima nasprotnik zraven ozemlja)
                    - potem pride na vrsto centralno naselje
                 
                    - lahko bi še za izboljšavo dodal, da vojaki, ki ostanejo, se dodelijo naseljem, kjer je največ sosedov "nasprotnikov"
                */

                while (tehnoloskiVisek > 0)
                {
                    //Console.WriteLine("\t\t\t---> WHILE -> tehnoloskiVisek > 0\t\t | tehnoloski visek: " + tehnoloskiVisek);
                    maxPovprecje = zbirka[0].povprecje;
                    tmpIndex = 0;
                    najdenMax = false;

                    // poiščemo, kateremu ozemlju bomo povečali enote
                    for (int j = 1; j < zbirka.Count; j++)
                    {
                        if ((zbirka[j].povprecje > maxPovprecje) && (zbirka[j].razlikaEnot > 0) && (zbirka[j].razlikaEnot > zbirka[tmpIndex].razlikaEnot))
                        {
                            maxPovprecje = zbirka[j].povprecje;
                            tmpIndex = j;
                            najdenMax = true;
                        }
                    }

                    if ((maxPovprecje != 1) && (najdenMax))
                    {
                        if (zbirka[tmpIndex].razlikaEnot < 0)
                            x = zbirka[tmpIndex].razlikaEnot * (-1);
                        else
                            x = zbirka[tmpIndex].razlikaEnot;


                        if ((trenutnaIgra.mapa.polja[zbirka[tmpIndex].index].steviloVojakov + x) < tehnoloskiVisek)
                        {
                            trenutnaIgra.mapa.polja[zbirka[tmpIndex].index].steviloVojakov = trenutnaIgra.mapa.polja[zbirka[tmpIndex].index].steviloVojakov + x;
                            tehnoloskiVisek = tehnoloskiVisek - x;
                        }
                        else
                        {
                            trenutnaIgra.mapa.polja[zbirka[tmpIndex].index].steviloVojakov = trenutnaIgra.mapa.polja[zbirka[tmpIndex].index].steviloVojakov + tehnoloskiVisek;
                            tehnoloskiVisek = 0;
                        }

                        //Console.WriteLine("\t\t\t---> NASELJE: " + zbirka[tmpIndex].index + " | tehnoloski visek: " + tehnoloskiVisek + " | novo stanje na ozemlju: " + trenutnaIgra.mapa.polja[zbirka[tmpIndex].index].steviloVojakov);
                    }
                    else
                    {
                        konec = false;

                        while (!konec)
                        {
                            rand = new Random();
                            tmpIndex = rand.Next(0, zbirka.Count);

                            trenutnaIgra.mapa.polja[zbirka[tmpIndex].index].steviloVojakov++;
                            tehnoloskiVisek--;

                            if (tehnoloskiVisek == 0)
                                konec = true;
                        }
                    }

                    tehnoloskiVisek = 0;
                }
                #endregion
            }
            #endregion

            zbirka.Clear();
        }
    }
}